    ;       SD- *************
    ; C    http://zvzd3d.ru/ekg
    ;  3.1xolt  pic18f26k42, 10.10.2023
    ;
    ;    mplab x ide 5.20 ( v5.10 - v5.35)
    
    ; **** ,   : 
    ; ChsN = 1,2  3 -     ( RA0,RA1,RB0,    )
    ;            

    ; :
    ;   CS SD-    RA5. 
    ;     RA0,RA1,RB0.  AN2,3       . 
    ;          .  ( RA4), 
    ;     (  AN2,3    ),      . 
    ;       .  (RA4)   , 
    ;      .
    ;  1 ,      16  (12   +   40  div 2.5). 
    ;  2 ,    20     2 
    ;  3 ,    13 ,    
    ;     RC1 (CCP2),       R-
    ;   R-   !!!
    ;      SD-  :    ,    
    ;  RTC ds3231,  MPU-6050,  bmp280
    ;    ,   / 
    
    
    ;   18F26k42,     . pic18f26k42 ,
    ;    .
    ;  ()   2 ,     pic18f25k42 -    
    ;    ,      
    ;
    list	 p=18F26k42

    #include p18f26k42.inc
    
    RADIX dec

    EXPAND

    ; ,       F (  W, .. 
    ;      W),   ACCESS (   BANKED). !
    ;
    #define f 1

    #define GO (0)
   
    #define SecMonitor_Org   0x000; //       ( 0)
    #define UserCode_Org     0x400; //      

    #define Led_Lat   (LATC)    ;  ,     
    #define Led_Tris  (TRISC)  
    #define Led_Bit   (1)       ;    RC1 (CCP2)
    #define Led_ODCON (ODCONC)  ;     
    
    
    __CONFIG _CONFIG1L, _FEXTOSC_HS_1L & _RSTOSC_EXTOSC_4PLL_1L
    __CONFIG _CONFIG1H, _CLKOUTEN_OFF_1H & _PR1WAY_OFF_1H & _CSWEN_ON_1H & _FCMEN_OFF_1H
    __CONFIG _CONFIG2L, _MCLRE_EXTMCLR_2L & _PWRTS_PWRT_64_2L & _MVECEN_OFF_2L & _IVT1WAY_OFF_2L & _LPBOREN_OFF_2L & _BOREN_SBORDIS_2L
    __CONFIG _CONFIG2H, _BORV_VBOR_2P7_2H & _ZCD_OFF_2H & _PPS1WAY_OFF_2H & _STVREN_OFF_2H & _DEBUG_OFF_2H & _XINST_OFF_2H
    __CONFIG _CONFIG3L, _WDTCPS_WDTCPS_13_3L & _WDTE_ON_3L; _WDTCPS_WDTCPS_13_3L - 8  
    __CONFIG _CONFIG3H, _WDTCWS_WDTCWS_7_3H & _WDTCCS_LFINTOSC_3H
    
    __idlocs _IDLOC0, 'N'
    __idlocs _IDLOC1, 'i'
    __idlocs _IDLOC2, 'k'
    __idlocs _IDLOC3, 'y'
    __idlocs _IDLOC4, 'E'
    __idlocs _IDLOC5, 'K'
    __idlocs _IDLOC6, 'G'
    __idlocs _IDLOC7, '2'
    



    cblock 0x0;     
        ;          (,  ,  FSR0L)
        ;   Monitor_DetectMemoryCmd,   OutByte
        WaitST
        WaitST2
        ;
        MonitorInitSignature: 2;  ,      
        ;
        MonitorCrc8
        MonitorOutByte        
        ;
        MonitorCanCont
        ;
        MonitorWorkTime
        MonitorIsKbrdPres
        MonitorLedShim
        MonitorGetByteTimeCount
        ;
    endc
    ;
    ;
    ;
MacroAddCrc8 macro Crc8
    xorwf Crc8
    movlw 0
    btfsc Crc8, 0
    xorlw 0xd5
    btfsc Crc8, 1
    xorlw 0x7f
    btfsc Crc8, 2
    xorlw 0xfe
    btfsc Crc8, 3
    xorlw 0x29
    btfsc Crc8, 4
    xorlw 0x52
    btfsc Crc8, 5
    xorlw 0xa4
    btfsc Crc8, 6
    xorlw 0x9d
    btfsc Crc8, 7
    xorlw 0xef
    movwf Crc8  
    endm
    ;
    ;
    ;
    ;
    ;
    org SecMonitor_Org + 0x0;    -    
    ;
    bra STARTER_ENTRY_POINT
    ;
    org SecMonitor_Org + 0x2;         
    bra USER_CODE_IRQ2_Enter 
    goto USER_CODE_ENTRY_POINT + 8  
    ;
    org SecMonitor_Org + 0x8;      
    goto USER_CODE_ENTRY_POINT + 8
    ;
    ;
    ;
    ;
    org SecMonitor_Org + 0xc;      ( 1)
    ;
Usart_Init:   bra __Usart_Init
Usart_In:     bra __Usart_In
Usart_Out:    bra __Usart_Out
Mem_ReadFlash_Disabled:  return
Mem_WriteFlash_Wait_Dis:  return
Mem_WriteFlash_Write_Dis: return
    ;
    ;
    ;
    ;
    org SecMonitor_Org + 0x18;       
    goto USER_CODE_ENTRY_POINT + 0x18
    ;
    ;
    org SecMonitor_Org+0x20;      ( 2)
    ;
Monitor_DetectMemoryCmd_Disabled: return
    ;
    ;
USER_CODE_IRQ2_Enter: 
    goto USER_CODE_ENTRY_POINT + 0x18    

    ;
    ; *********************************************************************************************
    ;    Usart
    ;
__Usart_Init:
    banksel U1CON0    
    movlw b'10110000'; D7=BRGS=1  HiSpeed. D6=ABDEN (Auto-baud Detect), D5=TXEN=1, D4=RXEN, D3:D0 - MODE (0-Asynchronous 8-bit UART mode)
    movwf U1CON0, BANKED
    movlw b'10000000'; D7=ON
    movwf U1CON1, BANKED
    movlw b'10000000'; D7=RUNOVF, 1 -  .   
    movwf U1CON2, BANKED
    ;movlw 139-1; 115200    64 
    movlw 174-1; 57600    40 
    movwf U1BRG, BANKED
    clrf U1BRGH, BANKED
    ;
    ; RC7(RXx/DTx)  RC6(TXx/CKx)
    bsf TRISC, 7
    bsf LATC,  6;  ,         
    bcf TRISC, 6
    ;
    ;     RC7,     ()           
    banksel ANSELC
    bcf ANSELC, 7, BANKED
    bcf ANSELC, 6, BANKED;       
    ;
    return
    ;
    ;
    ;
    ; *********************************************************************************************
    ;   W.   ,  
    ;
__Usart_Out:
    banksel PIR3
    btfss PIR3, U1TXIF, BANKED
    ;banksel U1FIFO
    ;btfsc U1FIFO, TXBF, BANKED; U1FIFO.TXBF = ~PIR3.U1TXIF 
    bra __Usart_Out
    banksel U1FIFO
    movwf U1TXB, BANKED
    return
    ;
    ;  
    ; :  W -  -    0.5 
    ; : W -  , C==1,     TimeOut
    ;         FSR0L ,   -  !
__Usart_In:
    movwf FSR0L
Usart_In_L1:
    ;
    movlw 223;       0.5   64  
Usart_In_L2:
    banksel U1FIFO
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    btfss U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    bra Usart_In_End
    addlw -1
    bnz Usart_In_L2
    decfsz FSR0L
    bra Usart_In_L1
    bsf STATUS, C
    return
    ;
Usart_In_End:
    bcf STATUS, C
    btfsc U1ERRIR, FERIF, BANKED
    bsf STATUS, C
    movf U1RXB, w, BANKED
    return
    ;
    ;
    ;
    ;
    ;    
    ;     *************************************************************************
    ;  .. Nik3383279@rambler.ru 
    ; 
STARTER_ENTRY_POINT:  
    ;goto USER_CODE_ENTRY_POINT    
    clrf INTCON0;      
    ;
    movlw 0xda
    movwf MonitorInitSignature
    movlw 0x5b
    movwf MonitorInitSignature+1
    ;
    clrf INTCON0
    ;
    ;
    setf TRISA;    
    setf TRISB
    setf TRISC
    ;
    ;
    ;     
    clrf T1GCON
    movlw b'00000001'; TMR1 ,  0
    movwf T1CON
    movlw b'00001';  Fosc/4
    movwf T1CLK
    ;
;    ; ***      ******************
;    ;
;    lfsr FSR0, 0x100
;    movlw 0xf9    
;MonStart_ClearRam1_L: 
;    movwf POSTINC0
;    btfss FSR0H, 4
;    bra MonStart_ClearRam1_L    
    ;
    ;
    ;
    BCF INTCON0,GIE
    ;
    BANKSEL PPSLOCK
    MOVLW 0x55
    MOVWF PPSLOCK, BANKED
    MOVLW 0xAA
    MOVWF PPSLOCK, BANKED
    ;
    BCF PPSLOCK,0, BANKED
    ;
    banksel RC6PPS
    movlw b'010011'; TX1
    movwf RC6PPS, BANKED
    ;
    banksel U1RXPPS
    movlw b'10111'; RC7
    movf U1RXPPS, w, BANKED
    ;
    ;
    ;  Usart
    rcall Usart_Init
    ;
    clrf MonitorCanCont
    ;setf MonitorCanCont;    -    
    ;
    movlw 0x55
    movwf MonitorOutByte
    ;
    clrf MonitorWorkTime
    clrf MonitorLedShim
    ;setf MonitorIsKbrdPres;   ,      
    clrf MonitorIsKbrdPres; ,    ,    
    ;
    ;
    ;
    ; ****      ***************************
    bcf Led_Tris, Led_Bit
    bcf Led_Lat, Led_Bit;   led,     
    ;
    ;banksel ANSELB
    ;bcf ANSELB, 5, BANKED; RB5 - ,  
    ;banksel INLVLA
    ;bcf INLVLB, 5, BANKED; RB5 - ,  TTL
    ;
    ;
    ;
MainLoop:
    clrwdt
    movlw 0xda
    subwf MonitorInitSignature, w
    bnz MainLoop_Reset
    movlw 0x5b
    subwf MonitorInitSignature+1, w
    bnz MainLoop_Reset
    ;
    btfsc MonitorCanCont, 0
    bra MainLoop_Cont
    ;
    movlw -50
    addwf MonitorWorkTime, w
    bnc MainLoop_Cont
    ;
    ;             
    btfss MonitorIsKbrdPres, 0;         , , ()   
    bra User_Start; //MaimLoop_CMD_User_Start
    ;    
MainLoop_Cont:
    ;
    rcall MainLoop_GetByte2
    bc MainLoop_NoData
    ;   
    ;
    ;
    sublw 0xcd
    bz MaimLoop_CMD
    ;
    sublw 0xcd;           (   )
    call Usart_Out
    bra MainLoop
    ;
    ;
    ;
MainLoop_Reset:
    reset
    goto 0
    ;
MainLoop_NoData:
    movf MonitorOutByte, w
    decf MonitorOutByte
    call Usart_Out
    bra MainLoop
    ;   
    ;
    ;    0.1          
MainLoop_GetByte2:
    clrf MonitorGetByteTimeCount    
MainLoop_GetByte2_L:
    movf TMR1H, w; -  
    subwf MonitorLedShim, w
    btfss STATUS, C
    bcf Led_Lat, Led_Bit
    btfsc STATUS, C
    bsf Led_Lat, Led_Bit
    ;
    ;
    ;btfsc PORTB, 5;   RB5
    ;clrf MonitorIsKbrdPres;   
    ;
    banksel PIR4
    btfss PIR4, TMR1IF, BANKED
    bra MainLoop_GetByte2_Rd    
    bcf PIR4, TMR1IF, BANKED
    ;
    incf MonitorGetByteTimeCount
    incf MonitorLedShim
    incf MonitorWorkTime;   4 
    bnz MainLoop_GetByte2_Rd
    ;
    ;  1    
    btfsc MonitorIsKbrdPres, 0 ;      
    setf MonitorCanCont        ;                 
    ;    
MainLoop_GetByte2_Rd:
    rcall MainLoop_CheckAndGetByte
    bnc MainLoop_GetByte2_Ret
    ;
    movlw -25
    addwf MonitorGetByteTimeCount, w
    bnc MainLoop_GetByte2_L
    ;    
MainLoop_GetByte2_TimeOut:
    bsf STATUS, C
MainLoop_GetByte2_Ret:
    return
    ;
    ;
    ;
    ;
MainLoop_CheckAndGetByte:
    bsf STATUS, C
    banksel U1FIFO
    btfsc U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    return
    bcf STATUS, C
    btfsc U1ERRIR, FERIF, BANKED
    bsf STATUS, C
    movf U1RXB, w, BANKED
    return
    ;
    ;
User_Start:
    clrf MonitorInitSignature
    clrf MonitorInitSignature+1
    ;
;    ; ***      ******************      *****************************
;    lfsr FSR0, 0x0
;    movlw 0xf9    
;User_Start_L: 
;    movwf POSTINC0
;    btfss FSR0H, 3
;    bra User_Start_L  
    ;
    movlw 0xbb
    call Usart_Out    
    ;
User_Start_WaitBB:
    banksel U1ERRIR
    btfss U1ERRIR, TXMTIF
    bra User_Start_WaitBB
    ;
    goto USER_CODE_ENTRY_POINT
    ;
    ;
    ;     
MaimLoop_CMD:
    rcall MainLoop_GetByte2
    bc MainLoop
    ;
    movwf FSR0L
    movwf MonitorCrc8
    ;
    sublw 0xcd
    bz MaimLoop_CMD_LockProg
    ;
    movf FSR0L, w
    sublw 0xeb
    bnz $+4
    bra User_Start; //MaimLoop_CMD_User_Start
    ;
    movlw 0xe6
    subwf FSR0L, w
    bz MaimLoop_CMD_ReadROM
    ;
    movlw 0xe7
    subwf FSR0L, w
    bz MaimLoop_CMD_WriteROM
    ;
    bra MainLoop
    ;   
    ;
MaimLoop_CMD_LockProg:
    rcall MainLoop_GetByte2
    bc MainLoop
    sublw 0xcd
    bnz MainLoop    
    rcall MainLoop_GetByte2
    bc MainLoop
    sublw 0xcd
    bnz MainLoop    
    setf MonitorCanCont
    bra MainLoop    
    ;
    ;
    ;
MaimLoop_CMD_ReadROM:
    rcall MainLoop_GetTBLPTR
    bc MaimLoop_CMD_ReadROM_Ret
    ;
    banksel NVMCON1
    BCF NVMCON1, REG0, BANKED ; point to Program Flash Memory
    BSF NVMCON1, REG1, BANKED ; access Program Flash Memory
    ;
    movlw 32
    movwf FSR0L
    ;
MaimLoop_CMD_ReadROM_L:
    tblrd*+
    movf TABLAT, w
    call Usart_Out
    decfsz FSR0L
    bra MaimLoop_CMD_ReadROM_L
    ;
MaimLoop_CMD_ReadROM_Ret:
    bra MainLoop
    ;
MaimLoop_CMD_WriteROM:
    rcall MainLoop_GetTBLPTR
    bc MaimLoop_CMD_WriteROM_Exit
    ;
    movlw 64
    movwf FSR1L
    ;
MaimLoop_CMD_WriteROM_L:
    rcall MainLoop_GetByte2
    bc MaimLoop_CMD_WriteROM_Exit
    movwf TABLAT
    tblwt*+    
    decfsz FSR1L
    bra MaimLoop_CMD_WriteROM_L
    ;
    tblrd*-
    ;
    movf TBLPTRU, w
    bnz MaimLoop_CMD_WriteROM_En
    movf TBLPTRH, w
    addlw -(USER_CODE_ENTRY_POINT>>8)
    bc MaimLoop_CMD_WriteROM_En
    ;
MaimLoop_CMD_WriteIgnore:
    movlw 0xEE
    call Usart_Out
MaimLoop_CMD_WriteROM_Exit:
    bra MainLoop
    ;
    ;
MaimLoop_CMD_WriteROM_En:
    ;
    banksel NVMCON1
    BCF NVMCON1, REG0, BANKED ; point to Program Flash Memory
    BSF NVMCON1, REG1, BANKED ; access Program Flash Memory    
    ;
    btfsc TBLPTRL, 6
    bra MaimLoop_CMD_WriteROM_Wr
    ;
    bsf NVMCON1, WREN, BANKED
    bsf NVMCON1, FREE, BANKED
    bcf INTCON0, GIE
    movlw 0x55
    movwf NVMCON2, BANKED
    movlw 0xaa
    movwf NVMCON2, BANKED
    bsf NVMCON1, WR, BANKED; ,  
    ;
    bcf NVMCON1, WREN, BANKED
    ;
    bra MaimLoop_CMD_WriteOK
    ;
MaimLoop_CMD_WriteROM_Wr:
    ;
    bsf NVMCON1, WREN, BANKED
    bcf NVMCON1, FREE, BANKED    
    bcf INTCON0, GIE
    movlw 0x55
    movwf NVMCON2, BANKED
    movlw 0xaa
    movwf NVMCON2, BANKED
    bsf NVMCON1, WR, BANKED; ,  
    ;
    bcf NVMCON1, WREN, BANKED
    ;
    ;
MaimLoop_CMD_WriteOK:
    movlw 0xAA
    call Usart_Out
    bra MaimLoop_CMD_WriteROM_Exit
    ;
    ;
MainLoop_GetTBLPTR:
    rcall MainLoop_GetByte2
    movwf TBLPTRL
    bc MainLoop_GetTBLPTR_Ret
    rcall MainLoop_GetByte2
    movwf TBLPTRH
    bc MainLoop_GetTBLPTR_Ret
    rcall MainLoop_GetByte2
    movwf TBLPTRU
MainLoop_GetTBLPTR_Ret:
    return
    ;
MaimLoop_CMD_Exit: 
    bra MainLoop
    ;
    ;
    ;
    ;   
    ;    
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ; *****************************************************************************************************************************************************
    ; *****************************************************************************************************************************************************
    ; **********************      ****************************************************************
    ; *****************************************************************************************************************************************************
    ; *****************************************************************************************************************************************************
    ;
ChsN equ 1       ;       ( 1-3)
    ;
    ;
    ;   ""  SD - : 
    ; ,           EmptyPos
    ;      EmptyPos  flash  
    ;   .    ""       
    ;    ! 
    ; 
FILE_GRANULA              equ 8;   8    1   -
    ;
    ;
    ;    I2C
    ;
;IC2DataBit equ 6           
;IC2SyncBit equ 7
IC2DataBit equ 5  ;               
IC2SyncBit equ 4
I2CPORT    equ PORTB  
I2CLAT     equ LATB   
I2CTRIS    equ TRISB  
I2C_ANSEL  equ ANSELB 
I2C_ODCON  equ ODCONB
    ;
    ;
    ;
    ;    SD / MMC 
    ;
CMD0_GO_IDLE_STATE        equ 0x40 + 0
CMD8_SEND_IF_COND         equ 0x40 + 8
CMD55_APP_CMD             equ 0x40 + 55
CMD58_READ_OCR            equ 0x40 + 58
ACMD41_SD_SEND_OP_COND    equ 0x40 + 41
CMD17_READ_SINGLE_BLOCK   equ 0x40 + 17
CMD18_READ_MULTY_BLOCK    equ 0x40 + 18
CMD12_STOPREAD            equ 0x40 + 12
CMD24_WRITE_BLOCK         equ 0x40 + 24
CMD25_WRITE_MULTY_BLOCK   equ 0x40 + 25
    ;
    ;
    ;
    ;   MMC_Init_Status -   SD-
    ;
MMCINIT_SD2               equ 0  ;   ,    SD >= 2.0
MMCINIT_HC                equ 1  ;   ,  SD HC
MMCINIT_INITOK            equ 2  ;   ,   SD  
MMCINIT_CANWRITE          equ 3  ;   ,  SD     
    ;
    ;
;AcpKDiv         equ (204) ;       AcpKDiv/256 ( )
AcpKDiv         equ (102) ;    2.5     AcpKDiv/256 ( )
         
AperN           equ (8)   ; .  ,   8
EkgPorogTauMul  equ (160) ;     EkgPorogTauMul/65536 
    ;
    ;
    ;
    cblock 0x20
        ;   USERa
        WaitST_res
        WaitST2_res
        ;        
        MMC_Init_Status;    SD-
        ;
        MMC_Adr: 4
        ReadMMCSize
        ReadMMCSpeed
        ;
        MMCWriteCmdR1
        MMCWriteDataRespToken        
        ;
        ;
        ;Shim_ST;       
        SysTime:4;      
        ;
        LoSysTime;         
        ;
        ACP_BufPos
        ACP_NNN
        ACP_CurCh
        ACP_Sum: 3
        ACP_Sum2: 3
        ACP_Sum3: 3
        ;
        ;
        ACP_ReadPos
        ;
	    EmptyPos: 4
        EmptyPosCode: 4
        ;
        File_StartAdr:4
        
        NakMode: 1
	
	TestStopCommandLen
	Acp_ValueL
	Acp_ValueH
	Acp_Div:2
	;
        ;
        I2C_Adress
        I2C_DataByte
        I2C_OutBitST
        I2C_Error
        ;
        DS1621_Cmd
        DS1621_Byte0
        DS1621_Byte1
        ;DS1621_Byte2
        MyBTMode
        ;
        CH2_Lo
        CH2_Hi
        ;	
        TMR1_B2
        TMR1_B3
        ;
        Input_Ch0
        Input_Ch1        
        ;
        Kbrd_Status
        ;
        Input_Ch2: 0
        U2BufPosWr
        U2DeciN:0
        U2BufPosRd
        
        
        ;
        
;	     Locked_Value: 0
;        Locked_L
;        Locked_H
         ;
;        LockAct
         ;
;        NewLock_T0: 4
;        NewLock_S: 4
;        NewLock_N: 4
;        ;
;        NewLockRes_T0: 4
;        NewLockRes_S: 4
;        NewLockRes_N: 4
        ;
        ;
        ;
        FastBankLastAdr: 0 ; 0x5f -  , !
    endc
    ;
    ; *********************************************************************
    ;   
    cblock 0x200
        ACP_MemoryBuffer:512  ;   .      FSRH
        WAVE_MemoryBuffer:0   ;       WAVE
    endc
    cblock 0x400
        ACP_MemoryBuffer2:512 ;      
    endc
    cblock 0x600
        ACP_MemoryBuffer3:512 ;      
    endc
    ;   
    cblock 0x100
        Kbrd_T1
        EmulValue: 2
        EmulU2: 3
        
        Acp_DeciN
        Acp_DeciValue:3
        Acp_DeciOldValue:3 
        Acp_Diff:3 
        ;
        Acp_Sqr:4
        ;
        ;        
        EkgProcessDataS: 0 ;  .  
        ;
        EkgBuf1: 8 * 4 ;     
        EkgNak1Pos: 1  ;      * 4    
        EkgS1: 5       ;   
        ;
        EkgS2: 5       ;      1, 2, ..., N
        ;
        EkgBuf3: 8 * 4 ;     
        EkgS3: 5       ;     
        ;
        EkgPorog: 4
        ;
        EkgDPorog: 4
        ;
        EkgLedStat: 1
        EkgLedN: 1
        EkgProcessDataE: 0
        ;
        DS3231_Time: 3         ;    0  7 : ,,
        DS3231_Time_DayOfWeek  ;  
        DS3231_Date: 3         ; , , 
        DS3231_Status          ;    0xF : Status
        DS3231_Aging_Offset    ; Aging Offset
        DS3231_THi             ; MSB of Temp
        DS3231_TLo             ; LSB of Temp
        ;
        BMP280_Izm_P_Hi    ;  0xF7 -   
        BMP280_Izm_P_Lo
        BMP280_Izm_P_l
        BMP280_Izm_T_Hi        
        BMP280_Izm_T_Lo
        BMP280_Izm_T_l
        ;
        BMP280_CalibrIndex ;     + I2C_Error   
        BMP280_CalibrValue ;    
        ;
        MPU6050_Izms: 2*4  ;    
        ;
    
    endc
    ;
    ;
    ;
    ;
WAIT2 macro
    bra $+2
    endm
    ;
WAIT3 macro
    nop
    bra $+2
    endm
    ;
WAIT4 macro
    rcall WAIT4T
    endm
    ;
WAIT5 macro
    rcall WAIT5T
    endm
    ;
WAIT6 macro
    rcall WAIT6T
    endm
    ;
    ;   32- 
INC32M macro Value
    local INC32M_EXIT
    incfsz Value 
    bra INC32M_EXIT
    incfsz Value+1
    bra INC32M_EXIT
    incfsz Value+2
    bra INC32M_EXIT
    incf Value+3
INC32M_EXIT:
    endm 
    ;
    ;   32-   Src  Dest
MOVE32M macro Dest, Src
    movf Src, w     
    movwf Dest
    movf Src+1, w
    movwf Dest+1
    movf Src+2, w
    movwf Dest+2
    movf Src+3, w
    movwf Dest+3
    endm    
    ;
    ;   16-  Arg1 = Arg1 + Arg2
ADD16M macro Arg1, Arg2 
    movf Arg2, w
    addwf Arg1
    movf Arg2+1, w
    addwfc Arg1+1
    ;
    endm
    ;
    ;       16-   Arg1 = Arg1 + (Arg2+128)
ADD16SigB macro Arg1, Arg2 
    movf Arg2, w
    addlw 128
    addwf Arg1
    btfsc STATUS, C
    incf Arg1+1
    endm
    ;
    ;   32- 
CLR32M macro Value
    clrf Value
    clrf Value+1
    clrf Value+2
    clrf Value+3
    endm
    ;
    ;   16- 
CLR16M macro Value
    clrf Value
    clrf Value+1
    endm
    ;
    ;
    ;   32-  Arg1 = Arg1 + Arg2
ADD32M macro Arg1, Arg2 
    movf Arg2, w
    addwf Arg1
    movf Arg2+1, w
    addwfc Arg1+1
    movf Arg2+2, w
    addwfc Arg1+2
    movf Arg2+3, w
    addwfc Arg1+3
    endm
    ;
    ;   32-  Arg1 = Arg1 - Arg2
SUB32M macro Arg1, Arg2 
    movf Arg2, w
    subwf Arg1
    movf Arg2+1, w
    subwfb Arg1+1
    movf Arg2+2, w
    subwfb Arg1+2
    movf Arg2+3, w
    subwfb Arg1+3
    endm
    ;
    ;
    ;  32- ,  C  Z . ,   Arg1 = Arg1 - Arg2
CMP32M macro Arg1, Arg2
    local CMP32M_EXIT
    movf Arg2+3, w
    subwf Arg1+3, w
    bnz CMP32M_EXIT
    movf Arg2+2, w
    subwf Arg1+2, w
    bnz CMP32M_EXIT
    movf Arg2+1, w
    subwf Arg1+1, w
    bnz CMP32M_EXIT
    movf Arg2, w
    subwf Arg1, w
CMP32M_EXIT:
    endm
    ;
    ;
    ;  32-     
COM32M macro Arg32
    comf Arg32
    comf Arg32+1
    comf Arg32+2
    comf Arg32+3
    endm
    ;
    ;    
XORL32M macro Arg32, ConstValue
    movlw low (ConstValue)
    xorwf Arg32
    movlw low ((ConstValue)>>8)
    xorwf Arg32+1
    movlw low ((ConstValue)>>16)
    xorwf Arg32+2
    movlw low ((ConstValue)>>24)
    xorwf Arg32+3
    endm
    ;
    ;
    ;       16- 
MWriteAcpBuf macro ValueWr
    lfsr FSR2, ACP_MemoryBuffer
    movf ACP_BufPos, w
    addwf FSR2L
    banksel ValueWr
    movf ValueWr, w, BANKED
    movwf INDF2
    bsf FSR2H, 0
    movf ValueWr+1, w, BANKED
    movwf INDF2    
    incf ACP_BufPos
    endm
    ;
    ;       16- 
    ;     
MWriteAcpBufNCH macro ValueWr
    MWriteAcpBuf ValueWr
    MWriteAcpBuf ValueWr
    MWriteAcpBuf ValueWr
    MWriteAcpBuf ValueWr
    MWriteAcpBuf ValueWr
    endm
   ;
    
    
;JC  macro Label
;    btfsc STATUS, C
;    goto Label
;    endm
;    ;
;JNC macro Label
;    btfss STATUS, C
;    goto Label
;    endm
;    ;
;JZ  macro Label
;    btfsc STATUS, Z
;    goto Label
;    endm
;    ;
;JNZ macro Label
;    btfss STATUS, Z
;    goto Label
;    endm
    ;
    ;
	; **********************************************************************
    ;
Macro_WaitFlashEndWrite macro ;      -    
    local LL                  ;      EEADR  EEDATA
    banksel NVMCON1
    BCF NVMCON1, REG0, BANKED
    BCF NVMCON1, REG1, BANKED    
LL: btfsc NVMCON1, WR, BANKED
    bra LL
    endm
    ;
Macro_ReadFlash macro     ;    -  EEADR  EEDATA
    banksel NVMCON1
    BCF NVMCON1, REG0, BANKED
    BCF NVMCON1, REG1, BANKED    
    bsf NVMCON1, RD, BANKED
    endm    
    ;
Macro_WriteFlash macro    ;    -.  
    banksel NVMCON1
    BCF NVMCON1, REG0, BANKED
    BCF NVMCON1, REG1, BANKED    
    bsf NVMCON1, WREN, BANKED
    bcf INTCON0, GIE
    movlw 0x55
    movwf NVMCON2, BANKED
    movlw 0xaa
    movwf NVMCON2, BANKED
    bsf NVMCON1, WR, BANKED
    bcf NVMCON1, WREN, BANKED
    endm
    ;
    ;
    ;
    ; ************  ( )      ************
    ;
    ;        TMR1
IRQINCTMR1HI macro 
    banksel PIR4
	bcf PIR4, TMR1IF, BANKED
    incfsz TMR1_B2
    bra $+2
    incf TMR1_B3
    endm
    ;
    ;
    ;
    ;     USART 16-  (  Streem_OutByte)
Streem_OutWORD macro Value16
    movf Value16, w
    rcall Streem_OutByte
    movf Value16+1, w
    rcall Streem_OutByte
    endm
    ;
    ;     USART 32-  (  Streem_OutByte)
Streem_OutDWORD macro Value32
    movf Value32, w
    rcall Streem_OutByte
    movf Value32+1, w
    rcall Streem_OutByte
    movf Value32+2, w
    rcall Streem_OutByte
    movf Value32+3, w
    rcall Streem_OutByte
    endm
    ;
    ;
    ;   Value  CodeValue    
EmptyPosCoderM macro CodeValue, Value
    bcf STATUS, C
    rrcf Value+3, w
    xorwf Value+3, w
    movwf CodeValue+3
    rrcf Value+2, w
    xorwf Value+2, w
    movwf CodeValue+2
    rrcf Value+1, w
    xorwf Value+1, w
    movwf CodeValue+1
    rrcf Value+0, w
    xorwf Value+0, w
    movwf CodeValue+0
    endm
    ;
    ;
    ;   Value  CodeValue      CodeValue:
    ; NChange -   ,  FSR0L -    .
    ;   EmptyPosCode,  FILE_GRANULA,   ,
    ;    ,       .
    ; 
EmptyPosCodeAndTestChangeM macro CodeValue, Value, NChange
    local L3_NoCh, L2_NoCh, L1_NoCh, L0_NoCh
    clrf NChange
    bcf STATUS, C
    rrcf Value+3, w
    xorwf Value+3, w
    xorwf CodeValue+3, w
    bz L3_NoCh
    xorwf CodeValue+3
    incfsz NChange;   CF
    nop
    movlw 3
    movwf FSR0L
L3_NoCh:
    rrcf Value+2, w
    xorwf Value+2, w
    xorwf CodeValue+2, w
    bz L2_NoCh
    xorwf CodeValue+2
    incfsz NChange;   CF
    nop
    movlw 2
    movwf FSR0L
L2_NoCh:
    rrcf Value+1, w
    xorwf Value+1, w
    xorwf CodeValue+1, w
    bz L1_NoCh
    xorwf CodeValue+1
    incfsz NChange;   CF
    nop
    movlw 1
    movwf FSR0L
L1_NoCh:
    rrcf Value+0, w
    xorwf Value+0, w
    ;
    xorwf CodeValue+0      ;    [CodeValue+0] <-> W
    xorwf CodeValue+0, w
    xorwf CodeValue+0
    ;
    xorwf CodeValue+0, w   ;      FILE_GRANULA
    movf NChange
    btfss STATUS, Z
    andlw 0xff - (FILE_GRANULA-1);    ,   (FILE_GRANULA) 
    andlw 0xff
    bz L0_NoCh
    incf NChange
    clrf FSR0L
L0_NoCh:
    endm
    ;
    ;
    ;
    org UserCode_Org
    ;
#if FastBankLastAdr > 0x60
    error "FastBankLastAdr pere !!!!!!!!!!!!!!!!!!!!!!!!!! "
#endif
    ;
    ;
    ;
USER_CODE_ENTRY_POINT:
	bra USER_CODE_ENTRY_POINT__
USER_CODE_IRQ2: 
    return ;     
           ;  ,   UserCode_Org+0x18  
    bra USER_CODE_IRQ  ;      
    ;
    org UserCode_Org + 8    
USER_CODE_IRQ:
    banksel PIR4
    bcf PIR4, TMR2IF, BANKED
    goto USER_CODE_IRQ__
    ;
    org UserCode_Org + 0x18    
USER_CODE_IRQLL:
    banksel PIR3
    bcf PIR3, TMR0IF, BANKED
    call EKG_Process
    retfie FAST
    ;
    ;
    ;
USER_CODE_ENTRY_POINT__:
    ;
    clrwdt
    clrf INTCON0
    ;
	call Usart_InitUser
	;
    movlw 0xcc
    call Usart_Out
    movlw 0xdd
    call Usart_Out
    movlw 0xee
    call Usart_Out
    movlw 0xff
    call Usart_Out
    ;
    ;
    ;  A
    ; RA0=AN0, RA1=AN1, RA2=Vref-, RA3=Vref+, RA4=AN0_2, RA5-CS_SD
    clrf LATA;   A -   ( RA5 - CS )
    bsf LATA, 5; CS SD 
    setf TRISA 
    bcf TRISA, 5
    ;
    banksel ANSELA
    setf ANSELA, BANKED
    ;
    ;
    ;  B
    ; RB0-?, RB1=TX2, RB2=RX2, RB3-, RB4-SCL, RB5-SDA, RB6,7 - 
    setf TRISB;   B -   
    clrf LATB
    ;
    movlw b'11111111';      B ( )
    banksel ANSELB
    movwf ANSELB, BANKED    
    ;
    ;  RB3 - 
    banksel WPUB
    bsf WPUB, 3, BANKED   ;     
    banksel ANSELB
    bcf ANSELB, 3, BANKED ;     
    ;
    ;
    ;  
    ; RC0 - TX1_fast, RC1 - LED, RC2 - BT_On, RC3 - SCK, RC4 - SDI, RC5 - SDO, RC6 - TX1, RC7 - RX1
    setf TRISC ;   ,    
    clrf LATC  
    ;
    movlw 0
    banksel ANSELC
    movwf ANSELC, BANKED;      C -       (COM, CCP, SPI)
    ;
    bsf TRISC, 0 ;   TX2 -    
    bsf LATC, 0  ;   -   1
    ;
    bcf TRISC, 3; RC3, SCK (Master)
    bsf TRISC, 4; RC4, SDI
    bcf TRISC, 5; RC5, SDO 
    bcf TRISC, 2; RC2 -      
    bsf TRISC, 7; RC7, RX1
    bsf LATC,  6;  ,         
    bcf TRISC, 6; RC6, TX1
    ;
    bsf LATC, 2; RC2 -   2022
    ;
    bcf Led_Tris, Led_Bit
    bcf Led_Lat, Led_Bit;   led,   
    banksel Led_ODCON
    bsf Led_ODCON, Led_Bit, BANKED;   led    -   led   
    ;
    ;
    banksel WPUC
    bsf WPUC, 7, BANKED;      RX -	
    ;
    banksel I2C_ANSEL
    bcf I2C_ANSEL, IC2DataBit, BANKED;     I2C
    bcf I2C_ANSEL, IC2SyncBit, BANKED
    banksel I2C_ODCON
    bsf I2C_ODCON, IC2DataBit, BANKED;   
    bsf I2C_ODCON, IC2SyncBit, BANKED
    ;
    ; 
    ;      1->0    
    banksel IOCBP
    clrf IOCBP, BANKED  ;    
    movlw 8
    movwf IOCBN, BANKED ;     RB3
    clrf IOCBF, BANKED   
    ;
    ;
    ;
    ;  -   
    BANKSEL PPSLOCK
    MOVLW 0x55
    MOVWF PPSLOCK, BANKED
    MOVLW 0xAA
    MOVWF PPSLOCK, BANKED    ;
    BCF PPSLOCK,0, BANKED
    ;
    ;call Usart2_Init
    ;call Usart2_BTInit
    call Usart2_BTOff
    movlw -10
    movwf U2DeciN
    ; 
    clrf INTCON0
    ;
    ;     
    ;    
    lfsr FSR0, EkgBuf1
    movlw EkgProcessDataE - EkgProcessDataS
IniEkgL1:
    clrf POSTINC0
    addlw -1
    bnz IniEkgL1
    ;
    clrf Acp_ValueL;  ,  
    clrf Acp_ValueH
    setf ACP_NNN
    ;
;    banksel Acp_Diff
;    movlw 0x12
;    movwf Acp_Diff, BANKED
;    movlw 0x34
;    movwf Acp_Diff+1, BANKED
;    movlw 0xff
;    movwf Acp_Diff+2, BANKED
;    ;
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
;    call EKG_Process
 ;;   call EKG_Process
 ;   call EKG_Process
 ;   clrf Acp_Diff, BANKED
  ;  clrf Acp_Diff+1, BANKED
  ;;  call EKG_Process
  ;  
    
    
    
    
    
    
	;
	;
    ; *****  SPI1 ************************
    ;   -    SPI  ( ,    )
    bcf TRISC, 5; // RC5, SDO must have TRISC<5> bit cleared
    bsf TRISC, 4; // RC4, SDI
    bcf TRISC, 3; // RC3, SCK (Master) must have TRISC<3> bitcleared
    ;
    banksel RC3PPS
    movlw b'011110'; SPI1 SCK
    movwf RC3PPS, BANKED
    movlw b'011111'; SPI1 SDO
    movwf RC5PPS, BANKED
    movlw b'10100'; RC4
    movwf SPI1SDIPPS, BANKED
    ;
    banksel SPI1CON0
    clrf SPI1CON0, BANKED
    movlw b'00000011';  D7=EN=0, D2=0 (MSb first), D1=1 (master), D0=BMODE=1
    movwf SPI1CON0, BANKED
    ;
    ; CKE=1, CKP=0 -  mode0,  SCK     
    ; CKE=0, CKP=1 -  mode3,  SCK     
    ;
    ; D7=SMP=1 (1 = SDI sampled at the end of data output time), D6=CKE=1 (1 = Output data changes on transition from active to idle clock state)
    ; D5=CKP=0 (0 = Idle state for SCK is low level), D4=FST (Fast Start Enable)
    ; D2,D1,D0 -  SS,SDI,SDO
    movlw b'11010000'; d7=smp=1, mode0: d6=cke=1, D5=ckp=0, d4=1 (fast start) 
    ;movlw b'10110000'; d7=smp=1, mode3: d6=cke=0, D5=ckp=1, d4=1 (fast start) 
    movwf SPI1CON1, BANKED
    ;
    movlw b'111'; D2=SSET (Slave Select Enable), D1=TXR ( ), D0=RXR ( )
    movwf SPI1CON2, BANKED
    ;
    clrf SPI1STATUS, BANKED;    D7=TXWE (SPIxTxB was written while TxFIFO was full), D3=RXRE (SPIxRB was read while RxFIFO was empty)
    ;
    clrf SPI1TWIDTH, BANKED;      BMODE=1
    ;
    movlw b'0000'; 0000  Fosc
    movwf SPI1CLK, BANKED
    ;
    movlw 1;   F_select/(2*(BAUD+1))
    movwf SPI1BAUD, BANKED
    ;
    bsf SPI1CON0, EN, BANKED;  SPI1   
    ;
    banksel SLRCONC; . .   SPI1  TX2
    movlw b'11000110'; RC0-TX2, 1,2, RC3,4,5 - SPI1  
    movwf SLRCONC, BANKED
    ;
    banksel PIR2
    bsf PIR2, SPI1TXIF, BANKED;   ,   ,   
    bsf PIR2, SPI1RXIF, BANKED    
    ;
    ;
	;
    ;     
    clrf NakMode
    ;
	banksel ADCON0
    movlw b'10000100'
    movwf ADCON0, BANKED; D7 -  
    movlw 0
    movwf ADCON1, BANKED
    movlw 0
    movwf ADCON2, BANKED
    movlw 0
    movwf ADCON3, BANKED
    movlw 40/2-1;  = Fosc/2/(n+1)
    movwf ADCLK, BANKED
    ;movlw 0; 
    movlw b'00010010'
    movwf ADREF, BANKED
    movlw 1
    movwf ADPCH, BANKED; 
    clrf ADCP, BANKED;   ADC CHARGE PUMP CONTROL REGISTER
    clrf ADPREL, BANKED; PRECHARGE TIME
    clrf ADPREH, BANKED; PRECHARGE TIME
    ;
    movlw 0; //:       
    movwf ADCAP, BANKED;  ADDITIONAL SAMPLE CAPACITOR (  ?)
    ;
    movlw low 400;               Fosc (255  40  6.375, 400 - 10, 480-12   )
    movwf ADACQL, BANKED
    movlw 400>>8
    movwf ADACQH, BANKED
    clrf ADACT, BANKED; ADC AUTO CONVERSION TRIGGER
    ;
    ;
    ;      Irq
    movlw 16
    call Eeprom_Read_w    
    call InitInputChsFromW
    ;
    ;       
    movlw 17
    call Eeprom_Read_w    
    movwf MyBTMode
    ;
    ;
    ;
    ;   -     
    ;movlw b'10100101';  : 1.024,  
    ;banksel FVRCON
    ;movwf FVRCON, BANKED
    ;
	;
    ;     
    clrf T1GCON
    movlw b'00000001'; TMR1 ,  0
    movwf T1CON
    movlw b'00001';  Fosc/4
    movwf T1CLK
	;
;    movlw b'00000000'
;    movwf CCP1CON
;    ;movlw b'00000111';  16- 
;    movlw b'00000101';   
;    movwf CCP1CON;    
    ;
    clrf TMR1H    
    clrf TMR1L
    clrf TMR0
    ;
	;
	;
    movlw 16
    movwf WaitST
I2C_Init_Lp:
    call I2C_Stop
    decfsz WaitST
    bra I2C_Init_Lp
    ;
    call Init_Datchiki
    ;call Read_Datchiki

    ;
    ;    
    clrf MMC_Init_Status
    ;  
    call MMC_Init
    ;
    ;
;	movlw 0x56
;	movwf MMC_Adr
;	movlw 0x34
;	movwf MMC_Adr+1
;	movlw 0x12
;	movwf MMC_Adr+2
;   movlw 0
;	movwf MMC_Adr+3
; 	;
;    EmptyPosCoderM EmptyPosCode, MMC_Adr
;    ;
;	movlw 0xb7
;	movwf MMC_Adr
;	movlw 0x93
;	movwf MMC_Adr+1
;	movlw 0xf3
;	movwf MMC_Adr+2
;   movlw 0xa1
;	movwf MMC_Adr+3
;    ;
;    XORL32M MMC_Adr, 0xa1e8bdca
;    CMP32M MMC_Adr, EmptyPosCode
;    btfss STATUS, Z
;    bra NewLoop
;    ;
;    movlw 0
;    call Eeprom_Write_Set_EEADR
;    movf EmptyPosCode+0, w
;    call Eeprom_Write_EEADR_w
;    movf EmptyPosCode+1, w
;    call Eeprom_Write_EEADR_w
;    movf EmptyPosCode+2, w
;    call Eeprom_Write_EEADR_w
;    movf EmptyPosCode+3, w
;    call Eeprom_Write_EEADR_w     
    ;
	;
	;
	;
	;
    call ReadEmptyPosFromEEPROM     ;   EEPROM  EmptyPosCode    EmptyPos
    ;
    ;goto NewLoop
    ;
	MOVE32M File_StartAdr, EmptyPos ;       
    ;
    ;clrf Shim_ST
    clrf SysTime
    clrf SysTime+1
    clrf SysTime+2
    clrf SysTime+3
    ;    
    ;    
    banksel T2CLK
    movlw b'0001'; Fosc/4
    movwf T2CLK, BANKED
    movlw 128-1         ;  TMR2  39062.5  ( 256 ,  - 2)
    movwf T2PR, BANKED
    clrf T2HLT, BANKED    
    movlw b'10000001' ; ,  1,  2
    ;movlw b'10000111' ; ,  1,  8
    movwf T2CON, BANKED
    ;
	;
    clrf Kbrd_Status
    clrf CH2_Lo
    clrf CH2_Hi    
    banksel EmulValue
    movlw 0x55
    movwf EmulValue, BANKED
    movlw 0xaa
    movwf EmulValue+1, BANKED

    ;goto NewLoop    
    ;
    ;  
    
    banksel PIE4
    movlw b'10000000'; TMR0
    movwf PIE3, BANKED
    movlw b'00000100'; TMR2
    movwf PIE4, BANKED
    setf IPR4, BANKED;  
    clrf IPR3, BANKED;  
    movlw b'11100000'
    ;movlw b'00000000'    ; , IRQ  LOCK !!!
    movwf INTCON0
	;
    ;
    ;
    call StartMMCBlockWrite
	;
	clrf TestStopCommandLen
    ;
MainWriteLoop:
    clrwdt;      SD-,      
    ;
    ; ,      
    rcall TestStopCommand
    btfsc STATUS, Z
    bra MainWriteLoop_Exit
    ;
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    bra MainWriteLoop_NoChangeFlash    
    ;
    ;bra MainWriteLoop_NoChangeFlash
    ;
    movf EmptyPos+0, w;   ,     EEPROM   EmptyPos
    andlw (FILE_GRANULA-1)
    bnz MainWriteLoop_NoChangeFlash
    ;
    ;  EmptyPos  EmptyPosCode   :  WaitST   ,  FSR -
    ;   (   EmptyPosCode   FILE_GRANULA  )
    ; 
    EmptyPosCodeAndTestChangeM EmptyPosCode, EmptyPos, WaitST
    movf WaitST, w
    bz MainWriteLoop_NoChangeFlash
    decfsz WaitST, w
    bra MainWriteLoop_CoderFatalErr
    ;bra MainWriteLoop_NoChangeFlash
    ;
    ;  FSR -      EmptyPosCode
    ;       flash  
    ;
    movf FSR0L, w;                      EEPROM   c  
    call Eeprom_Write_Set_EEADR;           flash 
    movf FSR0L, w;                    ( FILE_GRANULA,    )
    addlw EmptyPosCode
    movwf FSR0L
    clrf FSR0H
    movf INDF0, w
    movwf NVMDAT, BANKED
    ;
    Macro_WriteFlash
    bsf INTCON0, GIE
    ;
	;
MainWriteLoop_NoChangeFlash:
    ;
    call Read_Datchiki
    ;
    ;
    btfsc MMC_Init_Status, MMCINIT_CANWRITE
    call MMC_OnCS_WaitEndOfWrite     
    ;
    ;    - Start Block Token
    movlw 0xfc
    rcall Streem_OutMMC
    ;
    ;    
    ;
    movlw 0xaa;              
    rcall Streem_OutByte
    movlw 0x55;      
    rcall Streem_OutByte
    movlw 0x39;      
    rcall Streem_OutByte
    movlw 0xa7;      
    rcall Streem_OutByte
    ;
    ;
    Streem_OutDWORD File_StartAdr   ;       
    ;
    ;
    ; Streem_OutDWORD EmptyPos      ;  OLD    
    ;
    movlw ChsN-1; //  : 1 -   
    rcall Streem_OutByte
    ;
    lfsr FSR1, DS3231_Date     ;  [3]  RTC (  RTC)
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    ;
    ;
    movf SysTime+0, w;       
    rcall Streem_OutByte
    movf SysTime+1, w
    rcall Streem_OutByte
    movf SysTime+2, w
    rcall Streem_OutByte
    movf SysTime+3, w
    rcall Streem_OutByte
    ;
    ;
    banksel Kbrd_T1
    btfss PORTB, 3;   RB3
    bra LLMain_KeyOn
    ;   
    movlw 1
    andwf Kbrd_Status ;    D7-D1,   SD  D0 
    movf SysTime+1, w ;    0.0262 
    movwf Kbrd_T1, BANKED
    bra LLMain_KeyEnd
    ;
LLMain_KeyOn: ;   
    movlw 2
    addwf Kbrd_Status ;   
    ; 
    movf Kbrd_T1, w, BANKED
    subwf SysTime+1, w ;    
    addlw -153         ; 153 - 4 
    bnc LLMain_KeyEnd
    ;    -   
    movf SysTime+1, w
    movwf Kbrd_T1, BANKED
    btfss LATC, 2
    bra LLMain_Key_BTOn
    call Usart2_BTOff
    bra LLMain_KeyEnd
    ;
LLMain_Key_BTOn:
    call Usart2_BTInit
LLMain_KeyEnd:
    movlw 2
    banksel IOCBF
    btfsc IOCBF, 3, BANKED  ;     - 
    addwf Kbrd_Status       ;   
    bcf IOCBF, 3, BANKED
    ;
    rrncf Kbrd_Status, w      ;    (    D7)
    bcf Kbrd_Status, 0        ;     SD-  D0
    rcall Streem_OutByte
    ;
    ;
    lfsr FSR1, DS3231_Time   ;  [3] (  RTC)
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    ;
    lfsr FSR1, DS3231_THi   ;  DS3231_THi  DS3231_TLo (  RTC)
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    ;
    ;
    ;
    lfsr FSR1, BMP280_Izm_P_Hi    ;  P_Hi  P_Lo  BMP280
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    swapf POSTINC1, w             ;  P_l
    movwf WaitST
    ;
    lfsr FSR1, BMP280_Izm_T_Hi    ;  T_Hi  T_Lo
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    movf POSTINC1, w
    iorwf WaitST, w
    rcall Streem_OutByte       ;     4    
    ;
    rcall Streem_OutByteFSR1   ;   BMP280_CalibrIndex  BMP280_CalibrValue 
    rcall Streem_OutByteFSR1
    ;
    ;
    ; 
    ;
    lfsr FSR1, MPU6050_Izms    ;  8   MCU6050 (+)
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    rcall Streem_OutByteFSR1
    movf I2C_Error, w         ;  MCP6050  
    rcall Streem_OutByte      ;    I2C  MCP6050
    ;
    ;
    ;
    movf CH2_Lo, w            ;         (CH2)
    rcall Streem_OutByte
    ;
    bcf CH2_Hi, 7
    btfsc LATC, 2  ;   
    bsf CH2_Hi, 7  ;    . CH2.D15
    ;
    bsf CH2_Hi, 6  ; CH2.D14 = 1,       TX1
    banksel RB1PPS
    movlw b'010011'; TX1
    cpfseq RB1PPS, BANKED
    bcf CH2_Hi, 6
    ;      
    movf CH2_Hi, w
    rcall Streem_OutByte    
    ;
    ;
    movlw 0                   ;  4  
    rcall Streem_OutByte    
    movlw 0
    rcall Streem_OutByte    
    movlw 0
    rcall Streem_OutByte    
    movlw 0
    rcall Streem_OutByte    
    ;
    ;
;    ;btfss NakMode, 7  ;   
;    bra LL_skp;
;    banksel EmulValue    ;      U2
;    infsnz EmulValue, f, BANKED
;    incf EmulValue+1, f, BANKED
;    movf EmulValue, w, BANKED
;    call U2_Out
;    banksel EmulValue
;    movf EmulValue+1, w, BANKED
;    call U2_Out
;LL_skp: 
    ;
    ;
#if (ChsN == 1)
    movlw (256-8-3-1-6 - 4)/1
#endif
#if (ChsN == 2)
    movlw (256-8-3-1-6 - 4)/2
#endif
#if (ChsN == 3)
    movlw (256-8-3-1-6 - 4)/3
#endif
    ;
    movwf WaitST    ;          
    ;
MainWriteLoop_OutLoop:
    ;
Wait_ACP_Data:
    movf ACP_ReadPos, w
    subwf ACP_BufPos, w
    bnz Wait_ACP_DataReady
    ;
    ;    -   -
    ; 
    bra Wait_ACP_Data
    ;
    ;
Wait_ACP_DataReady:
    lfsr FSR1, ACP_MemoryBuffer 
	movf ACP_ReadPos, w
    addwf FSR1L
    
    btfsc NakMode, 7
    incfsz U2DeciN
    bra LL_SD_Wr_ADC_1
    movlw -10
    movwf U2DeciN
    ;      ,      
    
;    banksel EmulValue    ;      U2
;    infsnz EmulValue, f, BANKED
;    incf EmulValue+1, f, BANKED
;    movf EmulValue, w, BANKED
;    call U2_Out
;    banksel EmulValue
;    movf EmulValue+1, w, BANKED
;    call U2_Out
;    bra LL_SD_Wr_ADC_1
    ;
    ;
    ;
    ;      SD-   ,    U2
    movf INDF1, w
    call U2_Out; ,  Streem_OutByte  W
    rcall Streem_OutByte
    bsf FSR1H, 0
    movf INDF1, w
    call U2_Out
    rcall Streem_OutByte
    bra LL_SD_Wr_ADC_2
    ;
    ;
    ;
LL_SD_Wr_ADC_1:
    movf INDF1, w
    ;banksel EmulValue
    ;movf EmulValue, w, BANKED
    rcall Streem_OutByte
	bsf FSR1H, 0
    movf INDF1, w
    ;banksel EmulValue
    ;movf EmulValue+1, w, BANKED
    rcall Streem_OutByte
    ;
    ;banksel EmulValue
    ;infsnz EmulValue, f, BANKED
    ;incf EmulValue+1, f, BANKED
    ;
LL_SD_Wr_ADC_2:
    ;
#if (ChsN > 1)         ;   
    incf FSR1H        
    movf INDF1, w
    rcall Streem_OutByte
	incf FSR1H
    movf INDF1, w
    rcall Streem_OutByte
#endif
    ;
#if (ChsN > 2)         ;   
    incf FSR1H        
    movf INDF1, w
    rcall Streem_OutByte
	incf FSR1H
    movf INDF1, w
    rcall Streem_OutByte
#endif
    ;
    incf ACP_ReadPos
    decfsz WaitST
    bra MainWriteLoop_OutLoop
    ;
    rcall Streem_OutMMC;    - CRC
    rcall Streem_OutMMC
    ;
    ;      SD-: < ,   CMD25, Data Response Token>
    movf MMC_Init_Status, w
    call Usart_Out
    movf MMCWriteCmdR1, w
    call Usart_Out
    movf MMCWriteDataRespToken, w
    call Usart_Out
    ;    
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    bra MainWriteLoop
    ;
    ;
    call SSP_ReadByte       ;    SD -       
    movwf FSR0L
    andlw 0x1f
    sublw 0x5
    btfsc STATUS, Z
    bra MainWriteLoop_WrOK   
    ; 
    ;       SD/MMC - 
    movf FSR0L, w             
    movwf MMCWriteDataRespToken   ;      
    ;
    bcf  MMC_Init_Status, MMCINIT_CANWRITE
    ;
    movlw CMD12_STOPREAD    ;         
    call MMC_Cmd 
    call MMC_OffCS          ;   SD-
    ;
    ;goto MainWriteLoop
    reset; 2017.01.30 -  ,     
    ;
    ;
    ;
MainWriteLoop_WrOK:
    INC32M EmptyPos
    bra MainWriteLoop
    ;
    ;
    ;
    ;
Streem_OutByteFSR1:
    movf POSTINC1, w
Streem_OutByte:
    call Usart_Out
    ;btfsc LATC, 2  ;   
    ;rcall MyIfU2_Out
Streem_OutMMC:
    btfsc MMC_Init_Status, MMCINIT_CANWRITE
    goto SSP_OutByte
    return
    ;
    ;
MyIfU2_Out:
    banksel EmulU2
    incf EmulU2+2, f, BANKED
    btfss EmulU2+2, 0, BANKED
    return
    movwf EmulU2, BANKED
    incf EmulU2+1, f, BANKED
    movf EmulU2+1, w, BANKED
    call U2_Out
    banksel EmulU2
    movf EmulU2, w, BANKED
    
    return
    
    ;
    ;  SD-        EmptyPos
    ;   ,   MMC_Init_Status   MMCINIT_CANWRITE
    ;    (CS=0)
    ;
StartMMCBlockWrite:
    movlw 0xff
    movwf MMCWriteCmdR1
    movwf MMCWriteDataRespToken
    bcf MMC_Init_Status, MMCINIT_CANWRITE
    ;
    btfss MMC_Init_Status, MMCINIT_INITOK
    return                                   ;  SD-  
    ;
    movf EmptyPos+2, w
    iorwf EmptyPos+3, w
    btfsc STATUS, Z
    return                                   ;    < 65536,   
    ;
    MOVE32M MMC_Adr, EmptyPos
    btfsc MMC_Init_Status, MMCINIT_HC
    bra StartMMCBlockWrite_UseHCAddres
    ;    
    clrf MMC_Adr+0                           ;    HC -      
    bcf STATUS, C
    rlcf EmptyPos+0, w
    movwf MMC_Adr+1
    rlcf EmptyPos+1, w
    movwf MMC_Adr+2
    rlcf EmptyPos+2, w
    movwf MMC_Adr+3
    btfsc STATUS, C
    return                                   ;     
    movf EmptyPos+3, w
    btfss STATUS, Z
    return                                   ;     
    ;
StartMMCBlockWrite_UseHCAddres:
    ;    
    rcall MMC_OnCS_WaitEndOfWrite    
    movlw CMD25_WRITE_MULTY_BLOCK
    rcall MMC_Cmd
    movwf MMCWriteCmdR1
    sublw 0
    btfss STATUS, Z
    bra MMC_OffCS                            ;     
    ;
    bsf MMC_Init_Status, MMCINIT_CANWRITE     ;   -      
    return
    ;
    ;
    ;  , SD- 
EndMMCBlockWrite: 
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    return
    bcf MMC_Init_Status, MMCINIT_CANWRITE
    rcall MMC_OnCS_WaitEndOfWrite    
    movlw 0xfd;       Stop Tran Token
    call SSP_OutByte
    bra  MMC_OffCS
    ;
    ;
MainWriteLoop_CoderFatalErr:
    ;   EmptyPos  EmptyPosCode    
    ;
    rcall EndMMCBlockWrite;       
    ;
    clrf MMCWriteCmdR1;            ( )
    movlw 5
    movwf MMCWriteDataRespToken
    ;    
    bra MainWriteLoop_NoChangeFlash
    ;
    ;
MainWriteLoop_Exit:
    rcall EndMMCBlockWrite  ;    SD-,    
    ;
    ;bsf STATUS, RP1        ;      EmptyPosCode  EEPROM 
    ;bsf STATUS, RP0;   
    ;btfsc EECON1, WR  
    ;goto $-2
    ;clrf STATUS
    ;
    bra EnterNewLoop
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ; **********************************************************************************
    ; **********************************************************************************
    ; **********************************************************************************
    ; **********************************************************************************
    ;       *********************************************
    ;        ,      
    ;      STOP     .
    ;      STOP      ,     
    ;     ,       
    ;
EnterNewLoop:
    clrf INTCON0
    call StopCommandSendUsart    
    ;
    ;call Usart2_BTInit
    ;
    clrf U2BufPosWr
    clrf U2BufPosRd
    ;incf U2BufPosWr
    
NewLoop:
    clrwdt
    btg Led_Lat, Led_Bit;    -  ,  clrwdt,  
	;movlw 250
    ;call Usart_In
    
    lfsr FSR0, ACP_MemoryBuffer3
    movf U2BufPosWr, w
    addwf FSR0L
    rcall ProgramLoop_U2CheckAndGetByte
    bc NewL_SkilB2
    movwf INDF0
    incf U2BufPosWr        
NewL_SkilB2:   
    
    rcall ProgramLoop_CheckAndGetByte
	bc NewLoop
    ;
    sublw 0xcd        
    bnz NewLoop
    movlw 250
    call Usart_In
    bc NewLoop
    movwf FSR0L
    ;
    sublw 12
    btfsc STATUS, Z
    bra CMD1
	;
    movf FSR0L,w
    sublw 10
    btfsc STATUS, Z
    reset
    ;
    movf FSR0L,w
    sublw 13
    btfsc STATUS, Z
    bra CMD2
	;
    movf FSR0L,w
    sublw 23
    btfsc STATUS, Z
    bra CMD4
	;
    movf FSR0L,w
    sublw 25
    btfsc STATUS, Z
    bra CMD5
	;
    movf FSR0L,w
    sublw 11
    btfsc STATUS, Z
    bra EnterNewLoop
	;
    movf FSR0L,w
    sublw 16
    btfsc STATUS, Z
    bra CMD3
	;
    movf FSR0L,w
    sublw 34
    btfsc STATUS, Z
    bra CMDE_ReadEmptyPos
	;
    movf FSR0L,w
    sublw 35
    btfsc STATUS, Z
    bra CMDE_WriteEmptyPos
    
    
	movf FSR0L,w
    sublw 40
    btfsc STATUS, Z
    goto PL_Cmd_Ext_U2

   	;movf FSR0L,w
    ;sublw 41
    ;btfsc STATUS, Z
    ;goto PL_Cmd_Ext_BTModeSet

    ;movf FSR0L,w
    ;sublw 27
    ;btfsc STATUS, Z
    ;bra CMD7
    ;
    movf FSR0L,w
    sublw 81
    btfsc STATUS, Z
    goto PL_Cmd_Ext_I2CUpr
    ;
    movf FSR0L,w
    sublw 82
    btfsc STATUS, Z
    goto PL_Cmd_Ext_I2CData
    ;
    movf FSR0L,w
    sublw 83
    btfsc STATUS, Z
    goto PL_Cmd_Ext_I2CDataIn
    ;
    movlw 0xee
    call Usart_Out
    bra NewLoop
    ;
    ;
CMD3:    
    rcall MMC_Init
    bra NewLoop
    ;
    ;
    ;
    ;   Usart 4   MMC_Adr
    ;
CMDs_WaitUsartAdr:
    movlw 250
    call Usart_In
    btfsc STATUS, C
    return
    movwf MMC_Adr+0
    movlw 250
    call Usart_In
    btfsc STATUS, C
    return
    movwf MMC_Adr+1
    movlw 250
    call Usart_In
    btfsc STATUS, C
    return
    movwf MMC_Adr+2
    movlw 250
    call Usart_In
    movwf MMC_Adr+3
    return
    ;
    ;
    ;         
    ;        
    ;    0xfe,      , 
    ;   R1  Data Error Token,    .
    ;    512,  CRC   0xaa, 0x79
CMD1:
    ;
    ;   Usart 4     
    rcall CMDs_WaitUsartAdr
    btfsc STATUS, C
    bra NewLoop
    ;
    ;   Usart      
    movlw 200
    call Usart_In
    btfsc STATUS, C
    bra NewLoop
    movwf ReadMMCSize
    ;    
    rcall MMC_Adr_KorrHC
    movlw 0x40;    SD -  "parameter error"
    bnz CMD1_Read_Error
    ;
    rcall MMC_OnCS_WaitEndOfWrite    
    ;
    movlw CMD17_READ_SINGLE_BLOCK
    rcall MMC_Cmd
    ;rcall MMC_Cmd_Skip; // ,     
    andlw 0xff
    btfss STATUS, Z
    bra CMD1_Read_Error
    ;
    ;       
    call MMC_WaitResp_Long
    ;call MMC_WaitResp_Long_Skip; // ,     
    call Usart_Out
    sublw 0xfe;                0xfe,    ,  
    bnz CMD1_OffMMC
    ;
    ;  0xfe -   : DATA, 2  CRC, 0x55
    ;
    movlw 0xff
    call SPI_Out;    ,     
    ;
CMD1_ReadUsart:
    ;     Usart    ReadMMCSize*2 
    movf ReadMMCSize, w
    movwf WaitST
CMD1_Loop:
    call SPI_ReadAndOut_Usart
    call SPI_ReadAndOut_Usart
    decfsz WaitST
    bra CMD1_Loop
    ;
    rcall CMD5_SkipDataProc
    ;
    movf ReadMMCSize, w
    bz CMD1_SendCRC
    ; 
    call SSP_ReadByte;    2  CRC (  ,  )
    call SPI_In; 
    ;
    movlw 0xaa       ;       ( CRC )       
    call Usart_Out
    movlw 0x79
    call Usart_Out
    bra CMD1_OffMMC
    ;
CMD1_SendCRC:
    ;          CRC
    call SPI_ReadAndOut_Usart
    call SPI_ReadAndOut_Usart
    call SPI_In;    
    bra CMD1_OffMMC
    ;
CMD1_Read_Error:    
    andlw 0x7f
    call Usart_Out
CMD1_OffMMC:
    rcall MMC_OffCS
    goto NewLoop
    ;
    ;
    ;
    ;    ,    
    ;  :  ,  /2,    (0-usart57600  k-115200*k)
    ; : 0x53,  R1   SD,   ,    
    ;         STOP
    ;      0xTT,  T -  115200,    
    ;    ,    STOP      
    ;         STOP
    ;           Usart,
    ;    ( R1)      STOP.
    ;  STOP    (  ),  ,
    ;      
    ;   - 0xfe, , CRC.   0xfe,     
    ;       1 ,     0x99, 0xaa, 0x12, 0x55
    ;
CMD5:
    bcf INTCON0, GIE
    ;
    ;   Usart 4     
    rcall CMDs_WaitUsartAdr
    btfsc STATUS, C
    bra NewLoop
    ;
    ;   Usart      
    movlw 250
    call Usart_In
    btfsc STATUS, C
    bra NewLoop
    movwf ReadMMCSize
    ; 
    ;   Usart    
    movlw 250
    call Usart_In
    btfsc STATUS, C
    bra NewLoop
    movwf ReadMMCSpeed
    ;
    movlw 0x53
    call Usart_Out
    ;
    rcall MMC_Adr_KorrHC 
    bz CMD5_AdrOK
    movlw 0x40
    call Usart_Out;   SD- = parametr error
    bra NewLoop;
    ;   
CMD5_AdrOK:
    rcall MMC_OnCS_WaitEndOfWrite    
    movlw CMD18_READ_MULTY_BLOCK
    rcall MMC_Cmd
    call Usart_Out
    addlw 0
    bnz CMD5_OffMMC;     -    ,  SD     
    ;
    call GetFastOutCode  ;   ReadMMCSpeed       
    ;movwf ReadMMCSpeed   
    ;movlw 0
    call Usart_Out       ;      (0- , 0x88, 0x77, 0x44)    
    ;
    addlw 0
    btfsc STATUS, Z
    bra CMD5_NoChangeSpeed
    ;
    ;    Usart     
    ;
    ;
    call EnableFastOut
    ;
    movlw 50          ;   1  (      
    movwf WaitST      ;     -,   Usart)
CMD5_Fast_StartWait:
    movlw 200
    rcall Delay1
    decfsz WaitST
    bra CMD5_Fast_StartWait
    ;
    ;
    movlw 0x99;
    call FastOut      ;    (    )      
    movlw 0xaa
    call FastOut
    movlw 0x12
    call FastOut
    movlw 0x55
    call FastOut
    ;
CMD5_NoChangeSpeed:
CMD5_Fast_Loop:
    clrwdt
    btg Led_Lat, Led_Bit;    -  ,  clrwdt,  	
    rcall TestStopCommand
    bz CMD5_Exit
    rcall MMC_WaitResp_Long   ;       
    movwf WaitST
    call FastOut             ;   SD (   ReadMMCSpeed)
    movf WaitST, w
    sublw 0xfe               ;   0xfe,    ,  
    bz CMD5_Fast_Data
    ;
    ;
CMD5_Exit:
    call DisableFastOut
    ;
    movlw 200                ;  20 ,    -    
    rcall Delay1
    ;
    movlw CMD12_STOPREAD     ;        
    rcall MMC_Cmd 
    call Usart_Out           ;   R1 
    rcall MMC_OffCS
    bra EnterNewLoop
    ;
CMD5_OffMMC:
    rcall MMC_OffCS
    bra NewLoop
    ;
CMD5_Fast_Data:
    ;  0xfe -   : DATA, 2  CRC, 0x55
    ;
    movlw 0xff
    rcall SPI_Out;     (SSP  )
    ;
    ; fast   (  ReadMMCSpeed)
    movf ReadMMCSize, w
    rcall ReadBlockSPI_And_FastOut
    movf ReadMMCSize, w
    rcall ReadBlockSPI_And_FastOut
    rcall CMD5_SkipDataProc
    ;
    movlw 1;   CRC
    rcall ReadBlockSPI_And_FastOut    ;
    rcall SPI_In;    . 
    rcall FastOut
    ;
    bra CMD5_Fast_Loop
    ;
    ;
    ;
CMD5_SkipDataProc:            ;           
    movf ReadMMCSize, w      
    sublw 0; w := 0 - w
    btfsc STATUS, Z
    return
    movwf WaitST
CMD5_SkipData_Loop:
	call SSP_ReadByte
	call SSP_ReadByte
    decfsz WaitST
    bra CMD5_SkipData_Loop
    return
    ;
    ;
    ;  MMC_Adr  HC SD:  ,  Z=1 
    ;
MMC_Adr_KorrHC:
    bsf STATUS, Z
    btfsc MMC_Init_Status, MMCINIT_HC
    return
    ;    
    ;    HC -  MMC_Adr      
    ;
    movf MMC_Adr+3, w
    btfss STATUS, Z
    return
    bcf STATUS, Z
    btfsc MMC_Adr+2, 7
    return
    ;
    movf MMC_Adr+2, w
    movwf MMC_Adr+3
    movf MMC_Adr+1, w
    movwf MMC_Adr+2
    movf MMC_Adr+0, w
    movwf MMC_Adr+1
    ;
    bcf STATUS, C
    rlcf MMC_Adr+1
    rlcf MMC_Adr+2
    rlcf MMC_Adr+3    
    ;
    clrf MMC_Adr
    return    
    ;
    ;
    ;
    ;
    ;
    ; 
    ;  FILL      
CMD2:
    ;   Usart 4    (Fill)  
    rcall CMDs_WaitUsartAdr
    btfsc STATUS, C
    bra NewLoop
    ;
    ;   Usart    
    movlw 250
    call Usart_In
    btfsc STATUS, C
    bra NewLoop
    movwf ReadMMCSize
    ;
    rcall MMC_OnCS_WaitEndOfWrite    
    movlw 0x58;        
    rcall MMC_Cmd
    call Usart_Out
    addlw 0
    btfss STATUS, Z
    bra CMD2_Write_Error
    ;
    rcall SSP_ReadByte;     
    ;
    ;     
    movlw 0xfe
    rcall SSP_OutByte
    clrf WaitST
CMD2_Loop:
    movf ReadMMCSize, w
    call SSP_OutByte
    movf ReadMMCSize, w
    call SSP_OutByte
    decfsz WaitST
    bra CMD2_Loop    
    ;
    call SSP_ReadByte;    - CRC
    call SSP_ReadByte
    ;
    call SSP_ReadByte;        
    ;movwf ReadMMCSize
    call Usart_Out
    ;
    ;call SPI_ReadByte;      
    ;
    ;call MMC_WaitEndOfWrite
    ;
    ;call MMC_WaitForWriteEnd
    ;
    ;movf ReadMMCSize, w
    ;call Usart_Out
    ;
    ; ,   
    rcall MMC_OffCS;   (CS:=1)    ;
    ;movlw 0x55
    ;call Usart_Out
    bra NewLoop
    ;
CMD2_Write_Error:    
    rcall MMC_OffCS
    movlw 0xee
    call Usart_Out
    bra NewLoop
    ;
    ;
    ;        
CMD4:
    ;   Usart 4      
    rcall CMDs_WaitUsartAdr
    btfsc STATUS, C
    bra NewLoop
    ;
    rcall MMC_OnCS_WaitEndOfWrite    
    movlw 0x58;        
    rcall MMC_Cmd
    call Usart_Out
    addlw 0
    btfss STATUS, Z
    bra CMD4_Write_Error
    ;
    rcall SSP_ReadByte;     
    ;
    ;     
    movlw 0xfe
    rcall SSP_OutByte
    clrf WaitST
CMD4_Loop:
    movlw 250
    call Usart_In
    rcall SSP_OutByte
    movlw 250
    call Usart_In
    rcall SSP_OutByte
    decfsz WaitST
    bra CMD4_Loop    
    ;
    rcall SSP_ReadByte;    - CRC
    rcall SSP_ReadByte
    ;
    rcall SSP_ReadByte;        
    call Usart_Out
    ;
    ; ,   
    rcall MMC_OffCS;   (CS:=1)    ;
    bra NewLoop
    ;
CMD4_Write_Error:    
    rcall MMC_OffCS
    movlw 0xee
    call Usart_Out
    bra NewLoop
    ;
    ; 
    ;
    ; ,   Usart -      ( ,   Z = 1)
    ;            
    ;
TestStopCommand:
    rcall ProgramLoop_CheckAndGetByte
	bnc TestStopCommand_OnRvc
    btfss LATC, 2 ;    ? 
    bra TestStopCommand_Exit_NZ    
    rcall ProgramLoop_U2CheckAndGetByte
    bc TestStopCommand_Exit_NZ
    bra TestStopCommand_OnRvcU2	
    ;
TestStopCommand_Exit_NZ:
	bcf STATUS, Z
    return ;    ,   Z=0
	;
    ;
TestStopCommand_OnRvc:
    btfsc TestStopCommandLen, 0
	bra TestStopCmd_SecondByteL
	;
	;     
	sublw 0xcd
    btfss STATUS, Z
    return;   0xcd
	;
	bsf TestStopCommandLen, 0;     
    bra TestStopCommand_Exit_NZ
	;
TestStopCmd_SecondByteL: ;     
	movwf FSR0L
    sublw 0xcd
    bz TestStopCommand_Exit_NZ
    bcf TestStopCommandLen, 0
    ;
	movf FSR0L, w
    sublw 11
    btfsc STATUS, Z
    return ;   ,   Z=1 -  U1
    ;
TestStopCmd_SecondProc:
    movf FSR0L, w
    sublw 0x50
    btfsc STATUS, Z
    bra TestStopCommand_50_AN0
    ;
    movf FSR0L, w
    sublw 0x51
    btfsc STATUS, Z
    bra TestStopCommand_51_AN1
    ;
    movf FSR0L, w
    sublw 0x52
    btfsc STATUS, Z
    bra TestStopCommand_52_NoRef
    ;
    movf FSR0L, w
    sublw 0x53
    btfsc STATUS, Z
    bra TestStopCommand_53_Ref12
    ;
    movf FSR0L, w
    sublw 0x54
    btfsc STATUS, Z
    bra TestStopCommand_54_Ref1
    ;
    movf FSR0L, w
    sublw 0x55
    btfsc STATUS, Z
    bra TestStopCommand_55_NakOn
    ;
    movf FSR0L, w
    sublw 0x56
    btfsc STATUS, Z
    bra TestStopCommand_56_NakOff
    ;
    movf FSR0L, w
    sublw 0x57
    btfsc STATUS, Z
    bra TestStopCommand_57_BTStartOut
    ;
    movf FSR0L, w
    sublw 0x58
    btfsc STATUS, Z
    bra TestStopCommand_58_BTStopOut
    ;
TestStopCommand_Exit:
    bcf STATUS, Z
    return;    ,    Z=0	
    ;
    ;
    ;
TestStopCommand_OnRvcU2:
    btfsc TestStopCommandLen, 1
	bra TestStopCmd_U2SecondByteL
	;
	;     
	sublw 0xcd
    btfss STATUS, Z
    return;   0xcd
	;
	bsf TestStopCommandLen, 1;     
    bra TestStopCommand_Exit_NZ
	;
    ;
TestStopCmd_U2SecondByteL:
    movwf FSR0L
    sublw 0xcd
    bz TestStopCommand_Exit_NZ
    bcf TestStopCommandLen, 1
    ;
    bra TestStopCmd_SecondProc
    ;
	;
	;
    ;
TestStopCommand_50_AN0:
    ;movlw 0
    ;banksel ADPCH
    ;movwf ADPCH, BANKED
    ;movlw 4
    ;movwf Input_Ch0
    ;movlw 0
    ;movwf Input_Ch1
    movlw 0
    rcall InitInputChsFromW
    
    Macro_WaitFlashEndWrite
    banksel NVMADRL
    movlw 16
    movwf NVMADRL, BANKED
    clrf NVMADRH, BANKED
    movlw 0
    movwf NVMDAT, BANKED
    movf INTCON0, w
    movwf FSR0L
    Macro_WriteFlash 
    movf FSR0L, w
    movwf INTCON0    
    ;
TestStopCommand_MyEnd:
    movf FSR0L, w
    call Usart_Out
    bra TestStopCommand_Exit    
    ;
TestStopCommand_51_AN1:
    ;movlw 1
    ;banksel ADPCH
    ;movwf ADPCH, BANKED
    ;movlw 0; //b'001000'; ANB0
    ;movwf Input_Ch0
    ;movlw 0; //b'001001'; ANB1
    ;movwf Input_Ch1
    movlw 0xff
    rcall InitInputChsFromW    
    ;
    Macro_WaitFlashEndWrite
    banksel NVMADRL
    movlw 16
    movwf NVMADRL, BANKED
    clrf NVMADRH, BANKED
    movlw 0xff
    movwf NVMDAT, BANKED
    movf INTCON0, w
    movwf FSR0L
    Macro_WriteFlash 
    movf FSR0L, w
    movwf INTCON0    
    ;
    bra TestStopCommand_MyEnd  
    
TestStopCommand_52_NoRef:
    banksel ADREF
    movlw b'00000000'
    movwf ADREF, BANKED
    bra TestStopCommand_MyEnd    
TestStopCommand_53_Ref12:
    banksel ADREF
    movlw b'00010010'
    movwf ADREF, BANKED
    bra TestStopCommand_MyEnd    
TestStopCommand_54_Ref1:
    banksel ADREF
    movlw b'00000010'
    movwf ADREF, BANKED
    bra TestStopCommand_MyEnd    
TestStopCommand_55_NakOn:
    bcf NakMode, 0
    bra TestStopCommand_MyEnd    
TestStopCommand_56_NakOff:
    bsf NakMode, 0
    bra TestStopCommand_MyEnd    
    ;
	;
TestStopCommand_57_BTStartOut:
    btfss LATC, 2 ;   
    bra TestStopCommand_MyEnd ;   -      
    ;
    movf MyBTMode, w
    addlw -0xa5
    bz LL_BTStartOutOnly100Hz;   
    ;
    bcf NakMode, 7
    ;
    banksel RB1PPS
    movlw b'010011'      ; TX1        
    movwf RB1PPS, BANKED ;    RB1
    bra TestStopCommand_MyEnd    
    ;
    ;
LL_BTStartOutOnly100Hz:    
    bsf NakMode, 7     ;    c    
    bra LL_BTStopToTX2 ;   RB1   TX2
    ;
    ;
TestStopCommand_58_BTStopOut:
    bcf NakMode, 7
    btfss LATC, 2 ;   
    bra TestStopCommand_MyEnd ;   -     
    ;
LL_BTStopToTX2:
    banksel RB1PPS
    movlw b'010110'      ;  TX2  -2
    movwf RB1PPS, BANKED ;    RB1
    bra TestStopCommand_MyEnd    
    ;
    ;
    ;
ProgramLoop_CheckAndGetByte:
    banksel U1FIFO
    bsf STATUS, C
    btfsc U1FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    return
    bcf STATUS, C
    btfsc U1ERRIR, FERIF, BANKED
    bsf STATUS, C
    movf U1RXB, w, BANKED
    return
	;
ProgramLoop_U2CheckAndGetByte:
    banksel U2FIFO
    bsf STATUS, C
    btfsc U2FIFO, RXBE, BANKED; RXBE: 1 = Receive buffer is empty.
    return
    bcf STATUS, C
    btfsc U2ERRIR, FERIF, BANKED
    bsf STATUS, C
    movf U2RXB, w, BANKED
    return
	;
    ;
    ;    Input_Ch0, Input_Ch1, Input_Ch2
    ;  W=0,      RA4
InitInputChsFromW:
    movwf FSR0L
    movlw 0
    movwf Input_Ch0
    movlw 1
    movwf Input_Ch1
    movlw b'001000'; 001000 = ANB0
    movwf Input_Ch2
    movf FSR0L, w
    bnz Input_ChsDefRet    
    movf Input_Ch1, w
    movwf Input_Ch2
    movf Input_Ch0, w
    movwf Input_Ch1
    movlw 4
    movwf Input_Ch0
Input_ChsDefRet: 
    return
    ;
    ;
    ;
StopCommandSendUsart:   ;   Usart     Stop
    movlw 0x5e
    call Usart_Out
    movlw 0x44
    call Usart_Out
    movlw 0xe7
    call Usart_Out
    movlw 0x23
    goto Usart_Out    
    ;
    ;
    ;
CMDE_ReadEmptyPos:      ;      
    movlw 0x71
    call Usart_Out
    rcall ReadEmptyPosFromEEPROM
    movf EmptyPos, w
    call Usart_Out
    movf EmptyPos+1, w
    call Usart_Out
    movf EmptyPos+2, w
    call Usart_Out
    movf EmptyPos+3, w
    call Usart_Out
    bra NewLoop
    ;
CMDE_WriteEmptyPos:     ;      
    rcall CMDs_WaitUsartAdr    
    btfsc STATUS, C
    bra NewLoop
    ;
    EmptyPosCoderM EmptyPosCode, MMC_Adr
    ;
    rcall CMDs_WaitUsartAdr    
    btfsc STATUS, C
    bra NewLoop
    ;
    XORL32M MMC_Adr, 0xa1e8bdca
    CMP32M MMC_Adr, EmptyPosCode
    btfss STATUS, Z
    bra NewLoop
    ;
    movlw 0
    rcall Eeprom_Write_Set_EEADR
    movf EmptyPosCode+0, w
    rcall Eeprom_Write_EEADR_w
    movf EmptyPosCode+1, w
    rcall Eeprom_Write_EEADR_w
    movf EmptyPosCode+2, w
    rcall Eeprom_Write_EEADR_w
    movf EmptyPosCode+3, w
    rcall Eeprom_Write_EEADR_w     
    ;
    movlw 0x71
    call Usart_Out
    bra NewLoop
    ;
    ;
    ;
    ;   EEPROM  EmptyPosCode     EmptyPos
    ;
ReadEmptyPosFromEEPROM:
    movlw 0
    rcall Eeprom_Read_w
    movwf EmptyPosCode+0
    movlw 1
    rcall Eeprom_Read_w
    movwf EmptyPosCode+1
    movlw 2
    rcall Eeprom_Read_w
    movwf EmptyPosCode+2
    movlw 3
    rcall Eeprom_Read_w
    movwf EmptyPosCode+3
    ;
    MOVE32M EmptyPos, EmptyPosCode    
    ;
    lfsr FSR0, EmptyPos+4;  EmptyPos
    movlw 8*4
    movwf WaitST
    bcf STATUS, C
ReadEmptyPosDecode1:
    movf WaitST, w
    andlw 7
    btfsc STATUS, Z
    decfsz FSR0L; decf   , ,  decfsz  
	nop
    btfsc STATUS, C
    btg INDF0, 7
    rlcf INDF0, w
    rlcf INDF0
    decfsz WaitST
    bra ReadEmptyPosDecode1
    ;
    ;  EmptyPos  FILE_GRANULA. : -     EEPROM 
    ;       
    ;
    movlw 0xff - (FILE_GRANULA-1) 
    andwf EmptyPos+0              
    return
    ;
    ;
    ;
    ;
    ;
    ;
    ;  SD - .     Usart:
    ;   0x57, (  CMD0)-1,     ,  
    ;     CMD8: R1 + 4  (R1==1,  )
    ;    R1  CMD1,   ,  
    ;   ( ),   CMD58_READ_OCR: R1+4  (R1==0,  ).
    ;        MMC_Init_Status.
    ;
MMC_Init:
    movlw 0x57
    call Usart_Out
    clrf MMC_Init_Status
    rcall MMC_OffCS;   (CS:=1)
    movlw 20
    rcall Delay1   ;  2 
    clrf FSR0L      ;   256    
    banksel SPI1CON2
	bsf SPI1STATUS, CLRBF, BANKED; reset the receive and transmit buffers, making both buffers empty    
MMC_Init_L1:   
    call SSP_ReadByte
    decfsz FSR0L
    bra MMC_Init_L1
    movlw 20
    rcall Delay1;     2     
    rcall MMC_OnCS;        
    movlw 200;         CMD0      
    movwf WaitST    
MMC_Init_L11:
    ;clrwdt; !!!
    movlw 50
    rcall Delay1;        5         
    rcall SSP_ReadByte;   0xff   
    clrf MMC_Adr
    clrf MMC_Adr+1
    clrf MMC_Adr+2
    clrf MMC_Adr+3
    movlw CMD0_GO_IDLE_STATE;     CMD0
    rcall MMC_Cmd
    addlw -1
    bz MMC_Init_L2;     1 (in idle state),    ,    L2
    decfsz WaitST
    bra MMC_Init_L11;       CMD0
    ; ,       CMD0
    call Usart_Out
MMC_Init_Exit:
    rcall MMC_OffCS
    movf MMC_Init_Status, w
    goto Usart_Out
    ;
MMC_Init_L2:
    call Usart_Out
    rcall SSP_ReadByte;   0xff   
    ;
    movlw CMD8_SEND_IF_COND;  HC:   CMD8 -      CRC
    rcall SSP_OutByte
    movlw 0
    rcall SSP_OutByte
    movlw 0
    rcall SSP_OutByte
    movlw 1
    rcall SSP_OutByte
    movlw 0xaa
    rcall SSP_OutByte
    movlw 0x87
    rcall MMC_Cmd_SendCRC
    call Usart_Out
    sublw 1          ;  CMD8 ,   1,     >= 2.0 SD Card
    movwf WaitST 
    rcall SSP_ReadByte;       CMD8      
    call Usart_Out
    iorwf WaitST
    rcall SSP_ReadByte
    call Usart_Out
    iorwf WaitST
    rcall SSP_ReadByte
    call Usart_Out
    sublw 1
    iorwf WaitST
    rcall SSP_ReadByte
    call Usart_Out
    sublw 0xaa
    iorwf WaitST, w
    btfsc STATUS, Z
    bsf MMC_Init_Status, MMCINIT_SD2; ,   SD >= 2.0
    ;
    ;   CMD1  ACMD41   ,   SD/  
    movlw 200  
    movwf WaitST
MMC_Init_L21:
    ;clrwdt; !!!
    movlw 50
    call Delay1;        5             
    ;call SPI_ReadByte;   0xff   
    ;movlw 0x41
    ;call MMC_Cmd;     CMD1
    ;movwf FSR
    ;;call Usart_Out
    ;sublw 0
    ;btfsc STATUS, Z
    ;goto MMC_Init_L3;   0 - ,    
    ;
    ;
    rcall SSP_ReadByte;   0xff       
    movlw CMD55_APP_CMD
    rcall MMC_Cmd
    andlw 0xff-1
    btfss STATUS, Z
    bra MMC_Init_L23;  ,   CMD55  
    ;
    btfsc MMC_Init_Status, MMCINIT_SD2
    bsf MMC_Adr+3, 6;   SD>=2.0,    HCS (D30,     HC)    
    ;
    rcall SSP_ReadByte;   0xff   
    movlw ACMD41_SD_SEND_OP_COND
    rcall MMC_Cmd
    addlw 0
    btfsc STATUS, Z
    bra MMC_Init_L3;   0 - ,    
MMC_Init_L23:
    ;
    clrf MMC_Adr+3;        HC
    rcall SSP_ReadByte;   0xff       
    movlw CMD55_APP_CMD
    rcall MMC_Cmd
    andlw 0xff-1
    btfss STATUS, Z
    bra MMC_Init_L22;  ,   CMD55  
    ;
    rcall SSP_ReadByte;   0xff   
    movlw ACMD41_SD_SEND_OP_COND
    rcall MMC_Cmd
    addlw 0
    btfsc STATUS, Z
    bra MMC_Init_L3;   0 - ,    
    ;
MMC_Init_L22:    
    decfsz WaitST
    bra MMC_Init_L21
    ; ,       
    call Usart_Out
    bra MMC_Init_Exit
    ;
MMC_Init_L3:
    call Usart_Out
    ;
    bsf MMC_Init_Status, MMCINIT_INITOK; ***     ***
    ;
    call SSP_ReadByte    ;   0xff   
    movlw CMD58_READ_OCR ;  OCR,    30   SD HC
    rcall MMC_Cmd
    call Usart_Out
    movwf FSR0L
    ;
    call SSP_ReadByte ;    OCR (D30  ,   HC)
    call Usart_Out
    movf FSR0L, f       ;   R1:   ,   OCR  
    btfss STATUS, Z
    andlw 0
    andlw 0x40
    btfss STATUS, Z
    bsf MMC_Init_Status, MMCINIT_HC
    ;    
    rcall SSP_ReadByte
    call Usart_Out
    rcall SSP_ReadByte
    call Usart_Out
    rcall SSP_ReadByte
    call Usart_Out
    bra MMC_Init_Exit
    ;
    ;
    ;
MMC_OnCS:             ;     CS:=0
    banksel SPI1CON2
	bsf SPI1STATUS, CLRBF, BANKED; reset the receive and transmit buffers, making both buffers empty    
	bcf LATA, 5
    goto SSP_ReadByte ;  1    CS (   )
    ;
MMC_OffCS:            ;     CS:=1
    rcall SSP_ReadByte ;      
    bsf LATA, 5  
    bra SSP_ReadByte ;    ,    
    ;
    ;
MMC_Cmd_Skip:
    rcall SSP_OutByte;    
    movlw 2
    movwf FSR1L;    
    bra MMC_Cmd_2020test
    ;
MMC_Cmd:
    rcall SSP_OutByte;    
    movlw 64
    movwf FSR1L;    
MMC_Cmd_2020test:
    movf MMC_Adr+3, w
    rcall SSP_OutByte;  4  
    movf MMC_Adr+2, w
    rcall SSP_OutByte
    movf MMC_Adr+1, w
    rcall SSP_OutByte
    movf MMC_Adr+0, w
    rcall SSP_OutByte
    movlw 0x95
MMC_Cmd_SendCRC:    
    rcall SSP_OutByte;    
    ; 
    bra MMC_Cmd_WaitLL;     ( MMC_WaitRespCmd)
    ;
    ;
MMC_WaitRespCmd:
    movlw 64
    ;
    ;     (  0xff )
    ;    w -   
MMC_WaitResp:    
    movwf FSR1L;        
MMC_Cmd_WaitLL:
    rcall SSP_ReadByte
    addlw -0xff 
    bnz MMC_Cmd_Ret
    decfsz FSR1L
    bra MMC_Cmd_WaitLL
MMC_Cmd_Ret:
    addlw +0xff
    return
    ;
    ;
    ;     0xff   
    ;    w -    256   
    ;
MMC_WaitResp_Long:
    clrf WaitST
MMC_WaitResp_Long_L1:
    clrf FSR0L
MMC_WaitResp_Long_L2:
    call SSP_ReadByte
    addlw -0xff 
    bnz MMC_WaitResp_Long_Ret
    decfsz FSR0L    
    bra MMC_WaitResp_Long_L2
    decfsz WaitST
    bra MMC_WaitResp_Long_L1
MMC_WaitResp_Long_Ret:
    addlw +0xff
    return
    ;
MMC_WaitResp_Long_Skip:
    movlw 32; 32 -         CMD1
    movlw 0
    movwf WaitST
    movlw 64
    movwf FSR0L
    bra MMC_WaitResp_Long_L2
    ;
    ;
    ;
    ;      
    ;
MMC_OnCS_WaitEndOfWrite:    
    rcall MMC_OnCS
    clrf WaitST
MMC_WaitEndOfWrite_L1:
    clrf FSR0L
MMC_WaitEndOfWrite_L2:
    rcall SSP_ReadByte    
    sublw 0
    btfss STATUS, Z   
    return
    decfsz FSR0L
    bra MMC_WaitEndOfWrite_L2
    decfsz WaitST
    bra MMC_WaitEndOfWrite_L1
    ;   ,    
    return
    ;
    ;
    ;
    ;
    ;
    ;
	;
	;
	;
	;
    ;
    ;     250*4  (0.1 ),  FSR0L 
Delay1:        
    movwf FSR0L
Delay1_L1:
    movlw 244
    nop
    nop    
Delay1_L2:
    addlw -1
    btfss STATUS, Z
    bra Delay1_L2
    decfsz FSR0L
    bra Delay1_L1
WAIT5T:
    nop
WAIT4T:
    return    
    ;
    ; 
    ;   w -     
Eeprom_Read_w:
    Macro_WaitFlashEndWrite
    movwf NVMADRL, BANKED
    clrf NVMADRH, BANKED
    Macro_ReadFlash ;    -  EEADR  EEDATA
    movf NVMDAT, w, BANKED
    return
    ;
    ;
    ;  W  EEPROM   EEADR++:     , 
    ;    W   EEADR 
    ; (  EEDATA = W    ,    
    ;  Eeprom_Write_Set_EEADR   ,     )
    ;
Eeprom_Write_EEADR_w:
    Macro_WaitFlashEndWrite
    movwf NVMDAT, BANKED
    Macro_WriteFlash
    Macro_WaitFlashEndWrite
    ;bsf INTCON0, GIE
    incf NVMADRL, BANKED
    return    
    ;
    ;
    ;  EEADR:=W,      
    ;
Eeprom_Write_Set_EEADR:
    Macro_WaitFlashEndWrite
    movwf NVMADRL, BANKED
    clrf NVMADRH, BANKED
    return    
    ;
    ; *********************************************************************
    ;
USER_CODE_IRQ__:
    movf ACP_CurCh, w;    ,    
    movwf FSR1L      ;  (   . )
    ;
    incf ACP_CurCh   ;   . 
    movlw ChsN
    cpfslt ACP_CurCh
    clrf ACP_CurCh
    ;
    infsnz ACP_NNN   ;    
    clrf ACP_CurCh   ;   ,      
    ;
    ;      ACP_CurCh
    movf Input_Ch0, w   ;        (  Input_Ch0, Input_Ch1)
    btfsc ACP_CurCh, 0
    movf Input_Ch1, w
    btfsc ACP_CurCh, 1
    movf Input_Ch2, w
    ;movlw b'111110'; 111110 = FVR buffer 1
    ;movlw b'111111'; 111111 = FVR buffer 2
    ;movlw b'111100'; 111100 = Temperature indicator
    ;movlw b'001000'; 001000 = ANB0
    ;
    banksel ADPCH
    movwf ADPCH, BANKED    ;       
    ;
    ;      ADRES
    ;
    banksel ADRESL
    movf ADRESL, w, BANKED
    movwf Acp_ValueL;       
    movf ADRESH, w, BANKED
    movwf Acp_ValueH
    ;
    bsf ADCON0, GO, BANKED ;       
    ;
    ;
    incf LoSysTime
    btfss LoSysTime, 2;              Pic16f873a
    bra LL_NoIncSysTime
    clrf LoSysTime
    ;   
    INC32M SysTime
LL_NoIncSysTime:
    ; 
    ;
    ;   Acp_Value,    FSR1L
    btfsc FSR1L, 0
    bra LL_OnlyNakCh2
    btfsc FSR1L, 1
    bra LL_OnlyNakCh3
    ;
    ;   0
    btfss NakMode, 0;   :  NakMode.D0=1,     
    bra LL_OnlyNakCh1_Nak
    movf Acp_ValueL, w 
    movwf ACP_Sum+0
    movf Acp_ValueH, w
    movwf ACP_Sum+1 
    clrf ACP_Sum+2
    bra LL_NakEnd
    ;
LL_OnlyNakCh1_Nak:    
    movf Acp_ValueL, w ;     ACP_Sum
    addwf ACP_Sum+0
    movf Acp_ValueH, w
    addwfc ACP_Sum+1 
    movlw 0
    addwfc ACP_Sum+2
    ;
LL_NakEnd:    
    ;
    movf ACP_NNN, w
    bz IRQ_SaveMulty
    retfie FAST;  -     
    ;
IRQ_SaveMulty:
    ;  ACP_NNN == 256,   -40
    movlw -40
    movwf ACP_NNN
    ;
    ;
#if (ChsN == 1)
    ;    ACP_Sum  40   2.5,       102/256  
    movf ACP_Sum+0, w
    mullw AcpKDiv
    movf PRODH, w
    movwf Acp_Div+0
    ;
    movf ACP_Sum+1, w
    mullw AcpKDiv
    movf PRODL, w
    addwf Acp_Div+0
    movlw 0
    addwfc PRODH, w
    movwf Acp_Div+1
    ;
    movf ACP_Sum+2, w
    mullw AcpKDiv
    movf PRODL, w
    addwf Acp_Div+1
#endif
    ;
#if (ChsN == 2)          ;  Acp_Div = ACP_Sum>>1,    16     
    rrcf ACP_Sum+2, w     
    rrcf ACP_Sum+1, w
    movwf Acp_Div+1
    rrcf ACP_Sum+0, w
    movwf Acp_Div+0
    ;
    rrcf ACP_Sum2+2      ;  ACP_Sum2 >>= 1
    rrcf ACP_Sum2+1
    rrcf ACP_Sum2+0
#endif
    ;
#if (ChsN == 3)          ;       ,  Acp_Div := ACP_Sum
    movf ACP_Sum+1, w
    movwf Acp_Div+1
    movf ACP_Sum+0, w
    movwf Acp_Div+0
#endif
    ;
    ;
    ;
    ;    Acp_Div    ACP_MemoryBuffer[ACP_BufPos]
    ;
    lfsr FSR2, ACP_MemoryBuffer
    movf ACP_BufPos, w
    addwf FSR2L
    ;
    incf ACP_BufPos, w    ;   
    subwf ACP_ReadPos, w
    btfsc STATUS, Z
    bsf Kbrd_Status, 0 ; bsf CH2_Hi, 7 ; bsf Kbrd_Status, 0        
    ;   
    banksel Acp_DeciValue
    ;
    movf Acp_Div, w
    movwf INDF2
    addwf Acp_DeciValue, f, BANKED;     Acp_DeciValue:3
    bsf FSR2H, 0
    movf Acp_Div+1, w
    movwf INDF2    
    addwfc Acp_DeciValue+1, f, BANKED
    movlw 0
    addwfc Acp_DeciValue+2, f, BANKED    
    ;
#if (ChsN > 1)   ;     
    incf FSR2H
    movf ACP_Sum2+0, w
    movwf INDF2
    incf FSR2H
    movf ACP_Sum2+1, w
    movwf INDF2
#endif
    ;
#if (ChsN == 3)  ;     
    incf FSR2H
    movf ACP_Sum3+0, w
    movwf INDF2
    incf FSR2H    
    movf ACP_Sum3+1, w
    movwf INDF2
#endif
    ;
    ;
    incf ACP_BufPos
    ;
    ;
    ;  
    clrf ACP_Sum+0
    clrf ACP_Sum+1
    clrf ACP_Sum+2
    clrf ACP_Sum2+0
    clrf ACP_Sum2+1
    clrf ACP_Sum2+2
    clrf ACP_Sum3+0
    clrf ACP_Sum3+1
    clrf ACP_Sum3+2
    ;    
    incfsz Acp_DeciN, f, BANKED
    bra IRQ_Not256
    ;
    ;  Acp_DeciValue      . ~100
    movlw -10
    movwf Acp_DeciN, BANKED
    ;
    movf Acp_DeciOldValue, w, BANKED;  Acp_Diff := Acp_DeciValue - Acp_DeciOldValue
    subwf Acp_DeciValue, w, BANKED
    movwf Acp_Diff, BANKED
    movf Acp_DeciOldValue+1, w, BANKED
    subwfb Acp_DeciValue+1, w, BANKED
    movwf Acp_Diff+1, BANKED
    movf Acp_DeciOldValue+2, w, BANKED
    subwfb Acp_DeciValue+2, w, BANKED
    movwf Acp_Diff+2, BANKED
    ;
    movf Acp_DeciValue, w, BANKED;     Acp_DeciOldValue := Acp_DeciValue
    movwf Acp_DeciOldValue, BANKED
    movf Acp_DeciValue+1, w, BANKED
    movwf Acp_DeciOldValue+1, BANKED
    movf Acp_DeciValue+2, w, BANKED
    movwf Acp_DeciOldValue+2, BANKED
    ;
    clrf Acp_DeciValue, BANKED;        Acp_DeciValue := 0  
    clrf Acp_DeciValue+1, BANKED
    clrf Acp_DeciValue+2, BANKED
    ;
    banksel PIR3
    bsf PIR3, TMR0IF, BANKED;    
    ;   
IRQ_Not256:
    retfie FAST
    ;
    ;
    ;
LL_OnlyNakCh2:
    btfsc NakMode, 0;   :  NakMode.D0=1,     
    bra LL_OnlyNakCh2_NoNak
    ;
    ;    ACP_Sum2
    movf Acp_ValueL, w
    addwf ACP_Sum2+0
    movf Acp_ValueH, w
    addwfc ACP_Sum2+1 
    movlw 0
    addwfc ACP_Sum2+2
    bra LL_NakEnd    
    ;
LL_OnlyNakCh2_NoNak:
    movf Acp_ValueL, w
    movwf ACP_Sum2+0
    movf Acp_ValueH, w
    movwf ACP_Sum2+1 
    clrf ACP_Sum2+2
    bra LL_NakEnd    
    ;
    ;
LL_OnlyNakCh3:
    btfsc NakMode, 0;   :  NakMode.D0=1,     
    bra LL_OnlyNakCh3_NoNak
    ;
    ;    ACP_Sum2
    movf Acp_ValueL, w
    addwf ACP_Sum3+0
    movf Acp_ValueH, w
    addwfc ACP_Sum3+1 
    movlw 0
    addwfc ACP_Sum3+2
    bra LL_NakEnd    
    ;
LL_OnlyNakCh3_NoNak:
    movf Acp_ValueL, w
    movwf ACP_Sum3+0
    movf Acp_ValueH, w
    movwf ACP_Sum3+1 
    clrf ACP_Sum3+2
    bra LL_NakEnd    
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ;      RS-232
    ;    Usart (57600 ),  Fast -   RC0 TX2 
    ;
    ;
EnableFastOut:          ;  Fast -  (  )
    banksel U1ERRIR
EnableFastOut_WaitU1End:
	btfss U1ERRIR, TXMTIF
    bra EnableFastOut_WaitU1End
	;
	bcf INTCON0, GIE
	;
    bsf TRISC, 6                ;  RC6    (   )
    bcf U1CON0, TXEN, BANKED    ;    (  )  
    ;    
    bsf LATC, 0                 ;            
    bcf TRISC, 0                ;    RC0 (  )
    ;
    banksel U2CON0
    bsf U2FIFO, TXBE            ;    
    bsf U2CON0, TXEN, BANKED    ;    2  
    return
    ;
    ;
DisableFastOut:
    bsf TRISC, 0        ;  RC0    (   )
    ;
    banksel U2CON0
    bcf U2CON0, TXEN, BANKED    ;    2  
    ;
    ;
    bsf LATC, 6                 ;            
    bcf TRISC, 6                ;    RC6, TX1 (  )
    ;
    banksel U1CON0
    bsf U1CON0, TXEN, BANKED    ;   
    ;
    return
    ;
    ;
    ;
    ;    ,  ReadMMCSpeed
    ;     FastOut  ReadBlockSPI_And_FastOut
    ;
GetFastOutCode:
    btfsc LATC, 2
    call Usart2_BTOff   ;    ,   fast
    ;
    movlw 4
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x4
    movlw 7
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x7
    movlw 8
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x8
    movlw 10
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x10
    movlw 11
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x11
    movlw 21
    subwf ReadMMCSpeed, w
    bz GetFastOutCode_x21
    ;
    retlw 0x00
    ;
    ;
GetFastOutCode_x4:
    banksel U2BRG
    movlw 22-1; 115200*4    40 
    movwf U2BRG, BANKED        
    retlw 0x44               ; 460800 = 115200*4  ReadMMCSpeed == 4
    ;
GetFastOutCode_x7:
    banksel U2BRG
    movlw 12-1; 115200*7    40 
    movwf U2BRG, BANKED    
    retlw 0x77               ; 806400 = 115200*7  ReadMMCSpeed == 7
    ;
GetFastOutCode_x8:
    banksel U2BRG
    movlw 11-1; 115200*8    40 
    movwf U2BRG, BANKED    
    retlw 0x88               ; 921600 = 115200*8  ReadMMCSpeed == 8
    ;
GetFastOutCode_x10:
    banksel U2BRG
    movlw 8-1; 1200000   40 ,  1250000
    movwf U2BRG, BANKED    
    retlw 10
    ;
GetFastOutCode_x11:
    banksel U2BRG
    movlw 8-1; 1228800 = 115200*10.6666    40 ,  1250000
    movwf U2BRG, BANKED    
    retlw 11
    ;
GetFastOutCode_x21:
    banksel U2BRG
    movlw 4-1; 2457600 = 115200*21.3333    40 ,  2500000
    movwf U2BRG, BANKED    
    retlw 21
    ;
    ;
    ;
    ;   W   Usart,   Fast (RC0)    ReadMMCSpeed
    ;
FastOut:
    movf ReadMMCSpeed
    bz OutUsart1Proc;    Usart1  ReadMMCSpeed == 0
    ;     Usart2
OutUsart2Proc:
    banksel PIR6
    btfss PIR6, U2TXIF, BANKED
    bra OutUsart2Proc
    banksel U2FIFO
    movwf U2TXB, BANKED
    return
    ;
OutUsart1Proc:
    goto Usart_Out
    ;
    ;
    ;    W  SPI   Usart,   Fast (RC0)
    ;
ReadBlockSPI_And_FastOut:
    movwf WaitST
    movf ReadMMCSpeed, w
    bz ReadBlockSPI_And_OutUSART_L
    ;
    ;     TX2
ReadBlockSPI_And_FastOutLoop:    
    rcall SSP_ReadByte
    rcall OutUsart2Proc
    decfsz WaitST
    bra ReadBlockSPI_And_FastOutLoop
    return
    ;
    ;      Usart1  ReadMMCSpeed == 0
ReadBlockSPI_And_OutUSART_L:
    rcall SPI_ReadAndOut_Usart
    decfsz WaitST
    bra ReadBlockSPI_And_OutUSART_L
    return
    ;    
    ;
    ;   :   . ,   ( )
SPI_ReadAndOut_Usart:
    movlw 0xff
    rcall SPI_Out
    rcall SPI_In
    goto Usart_Out 
    ;
    ;
    ;
    ;
    ;
    ;  W,       
SSP_ReadByte:
    movlw 0xff
SSP_OutByte:
    banksel SPI1STATUS
    ;!!    ,     
    ;bsf SPI1STATUS, CLRBF, BANKED; Reset the receive and transmit buffers, making both buffers empty    
    rcall SPI_Out
    bra SPI_In
	;
	;    
    ;
    ;
    ;   W  FIFO,   ,   
SPI_Out:
    banksel PIR2
SPI_Out_WaitPlace:
    btfss PIR2, SPI1TXIF, BANKED; Set when TXFIFO is not full, and is cleared when the TXFIFO is full
    bra SPI_Out_WaitPlace
    banksel SPI1TXB
    movwf SPI1TXB, BANKED
    return
    ;
    ; ,      
    ;    SRMTIF    
SPI_WaitOutEnd:
    banksel SPI1INTF
SPI_WaitOutEnd_L:
    btfss SPI1INTF, SRMTIF, BANKED; SRMTIF=0  no data transfers have occurred or a data transfer is in progress
    bra SPI_WaitOutEnd_L
    bcf SPI1INTF, SRMTIF, BANKED; SRMTIF=0  no data transfers have occurred or a data transfer is in progress
    return
    ;
    ;
    ;    .    . 
SPI_In:
    banksel PIR2
SPI_In_Wait:    
    btfss PIR2, SPI1RXIF, BANKED; set when RXFIFO contains data, and is cleared when the RXFIFO empty.
    bra SPI_In_Wait    
    banksel SPI1RXB
    movf SPI1RXB, w, BANKED
    return
    ;
    ;
    ;
    ;
    ;
    ;   -  I2C. 
    ;  YY.D0==1,  .  YY.D1==1,  
PL_Cmd_Ext_I2CUpr:
    clrf I2C_Error
    call Usart_In
    bc PL_Cmd_Ext_I2CUpr_Exit
    movwf WaitST2
    btfsc WaitST2, 0
    call I2C_Start
    btfsc WaitST2, 1
    call I2C_Stop
    btfsc WaitST2, 2
    call I2C_RepStart
    btfsc WaitST2, 3
    call I2C_Input_Ask
    btfsc WaitST2, 4
    call I2C_Input_NAsk
PL_Cmd_Ext_I2CUpr_Exit:
    goto NewLoop    
    ;
    ;
    ;   -      I2C
    ; : I2C_Error
PL_Cmd_Ext_I2CData:
    call Usart_In
    bc PL_Cmd_Ext_I2CUpr_Exit
    movwf WaitST2
    ;
    movf WaitST2, w
    call I2C_Out
    movf I2C_Error, w
    call Usart_Out
    goto NewLoop    
    ;
    ;   -      I2C
PL_Cmd_Ext_I2CDataIn:
    call I2C_Input
    call Usart_Out
    ;call I2C_Input_Ask
    goto NewLoop    
    ;
    ;
    ;
PL_Cmd_Ext_U2:
    call Usart_In
    bc PL_Cmd_Ext_U2_Exit
    movwf WaitST
    movwf WaitST2
    btfsc WaitST, 7
    bra PL_Cmd_Ext_U2_Cmds
    ; [0-7f] -    TX2
    lfsr FSR1, ACP_MemoryBuffer2 ;     
PL_Cmd_Ext_TX2_L:
    movlw 256
    call Usart_In
    bc PL_Cmd_Ext_U2_Exit
    movwf POSTINC1
    decfsz WaitST
    bra PL_Cmd_Ext_TX2_L
    ;
    lfsr FSR1, ACP_MemoryBuffer2 ;   U2
PL_Cmd_Ext_TX2_L2:
    movf POSTINC1, w
    rcall U2_Out
    decfsz WaitST2
    bra PL_Cmd_Ext_TX2_L2
    ;
    movlw 0x76
    call Usart_Out
    bra PL_Cmd_Ext_U2_Exit
    ;
    ;
PL_Cmd_Ext_U2_Cmds:
    movf WaitST, w
    addlw -0x80
    bz PL_Cmd_Ext_GetRvcRX2
    addlw -1
    bz PL_Cmd_Ext_BTOn
    addlw -1
    bz PL_Cmd_Ext_BTOff
    addlw -1
    bz PL_Cmd_Ext_SetBaud
    addlw -1
    bz PL_Cmd_Ext_SetBTMode
    ;
    bra PL_Cmd_Ext_U2_Exit
    ;
    ;    
PL_Cmd_Ext_GetRvcRX2:
    movf U2BufPosRd,w
    subwf U2BufPosWr, w
    movwf WaitST
    call Usart_Out
    ;
    banksel U2FIFO
    movf U2FIFO, w, BANKED
    call Usart_Out
    banksel U2ERRIR
    movf U2ERRIR, w, BANKED
    call Usart_Out
    ;
    movf WaitST, w
    bz PL_Cmd_Ext_U2_Exit
PL_Cmd_Ext_RX2_L:
    lfsr FSR0, ACP_MemoryBuffer3
    movf U2BufPosRd, w
    addwf FSR0L
    movf INDF0, w
    call Usart_Out
    incf U2BufPosRd
    decfsz WaitST
    bra PL_Cmd_Ext_RX2_L
    bra PL_Cmd_Ext_U2_Exit
    ;
    ;
PL_Cmd_Ext_BTOn:
    rcall Usart2_BTInitAndKey
    movlw 0xa1
    call Usart_Out
    bra PL_Cmd_Ext_U2_Exit
    ;
PL_Cmd_Ext_BTOff:
    rcall Usart2_BTOff
    movlw 0xa8
    call Usart_Out
    bra PL_Cmd_Ext_U2_Exit
    ;
PL_Cmd_Ext_SetBaud:
    movlw 256
    call Usart_In
    bc PL_Cmd_Ext_U2_Exit
    movwf WaitST
    movlw 256
    call Usart_In
    bc PL_Cmd_Ext_U2_Exit
    banksel U2BRG
    movwf U2BRGH, BANKED
    movf WaitST, w
    movwf U2BRG, BANKED
    movlw 0xa4
    call Usart_Out
    bra PL_Cmd_Ext_U2_Exit
    ;  
    ;
PL_Cmd_Ext_SetBTMode:
    movlw 256
    call Usart_In
    bc PL_Cmd_Ext_U2_Exit
    movwf MyBTMode
    ;
    Macro_WaitFlashEndWrite
    banksel NVMDAT
    movwf NVMDAT, BANKED
    movlw 17
    movwf NVMADRL, BANKED
    clrf NVMADRH, BANKED
    Macro_WriteFlash 
    movf MyBTMode, w ; ,    
    bz LL_SetBTModeOK
    addlw -0xa5
    bz LL_SetBTModeOK
    movlw 0xa6 ;  -  !
    call Usart_Out    
    bra PL_Cmd_Ext_U2_Exit
LL_SetBTModeOK:
    movlw 0xa5
    call Usart_Out    
    bra PL_Cmd_Ext_U2_Exit
    ;
PL_Cmd_Ext_U2_Exit:
    goto NewLoop    
    ;
    ;
    ;
    ;
    ; *********************************************************************************************
    ;    Usart
    ;
Usart_InitUser:
    banksel U1CON0    
    movlw b'10110000'; D7=BRGS=1  HiSpeed. D6=ABDEN (Auto-baud Detect), D5=TXEN=1, D4=RXEN, D3:D0 - MODE (0-Asynchronous 8-bit UART mode)
    movwf U1CON0, BANKED
    movlw b'10000000'; D7=ON
    movwf U1CON1, BANKED
    movlw b'10000000'; D7=RUNOVF, 1 -  .   
    movwf U1CON2, BANKED
    ;movlw 174-1; 57600    40 
    movlw 87-1; 115200    40 
    movwf U1BRG, BANKED
    clrf U1BRGH, BANKED
    ;
    ; RC7(RX1/DT1)  RC6(TX1/CK1)
    bsf LATC,  6 ;   ,         
    bcf TRISC, 6 ;     
    ;
    ;     RC7,     ()           
    banksel ANSELC
    bcf ANSELC, 7, BANKED
    bcf ANSELC, 6, BANKED; -    , .. 
    ;
    banksel U1FIFO
    bsf U1FIFO, TXBE, BANKED    ;    
    bsf U1FIFO, RXBE, BANKED    ;   
    ;
    return
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
#define KOO_BT_115200 (87-1)
#define KOO_BT_57600 (174-1)
#define KOO_BT_38400 (260-1)
#define KOO_BT_19200 (521-1)
#define KOO_BT_9600 (1042-1)

#define KOO_BT (KOO_BT_115200)
;#define KOO_BT (KOO_BT_57600)
;#define KOO_BT (KOO_BT_38400)
;#define KOO_BT (KOO_BT_19200)
;#define KOO_BT (KOO_BT_9600)
    ;
    ;
Usart2_BTInitAndKey:
    bsf LATC, 2 ;   
    nop
    nop
    bsf LATB, 7 ;     RB7  Key,  HC-05    
    bcf TRISB, 7
    ;
Usart2_BTInit:
    bsf LATC, 2;   
    banksel U2RXPPS
    movlw b'01010'        ;  RB2   
    movwf U2RXPPS, BANKED ;   RX2  -2
    ;
    banksel ANSELB
    bcf ANSELB, 2, BANKED ;    RB2    
    bcf ANSELB, 1, BANKED
    ;
    ;
    banksel RB1PPS
    movlw b'010110'      ;  TX2  -2
    movwf RB1PPS, BANKED ;    RB1
    ;
    bsf LATB, 1  ;   1  ,         
    bcf TRISB, 1 ;  RB1 = TX2   
    ;
    ;
    banksel RC0PPS
    movlw 0 
    movwf RC0PPS, BANKED  ; RC0   TX2 
    bsf TRISC, 0          ;     
    ;
    banksel ANSELC
    bsf ANSELC, 0, BANKED ;       
    ;
    ;
    banksel U2CON0    
    movlw b'00000000'; D7=OFF -  -2  
    movwf U2CON1, BANKED
    ;
    movlw b'10110000'; D7=BRGS=1  HiSpeed. D6=ABDEN (Auto-baud Detect), D5=TXEN=1, D4=RXEN, D3:D0 - MODE (0-Asynchronous 8-bit UART mode)
    movwf U2CON0, BANKED
    movlw b'10000000'; D7=RUNOVF, 1 -  .   
    movwf U2CON2, BANKED
    movlw KOO_BT
    movwf U2BRG, BANKED
    movlw KOO_BT>>8
    movwf U2BRGH, BANKED
    ;
    banksel U2FIFO
    bsf U2FIFO, TXBE, BANKED    ;    
    bsf U2FIFO, RXBE, BANKED    ;   
    ;
    banksel U2CON1
    movlw b'10000000'; D7=ON
    movwf U2CON1, BANKED
    ;
    return
    ;
    ;
    ;
U2_Out:
    banksel PIR6
U2_Out_loop:
    btfss PIR6, U2TXIF, BANKED
    bra U2_Out_loop
    banksel U2FIFO
    movwf U2TXB, BANKED
    return
    ;
    ;
    ;  . -2   FastMode,  
Usart2_BTOff:
    ;
    bsf PORTB, 7 ;   RB7     Key  HC-05
    bcf LATB, 7
    ;
    bcf LATC, 2;       
    bcf NakMode, 7
    ;
    banksel U2RXPPS
    movlw b'01010'        ;  RB2   
    movwf U2RXPPS, BANKED ;   RX2  -2 (  fast   )
    ;
    ;
    banksel RC0PPS
    movlw b'010110';      ;  TX2  -2
    movwf RC0PPS, BANKED  ;     RC0
    bsf TRISC, 0          ;      
    bsf LATC, 0           ;  1    ,         
    banksel ANSELC
    bsf ANSELC, 0, BANKED ;  . RC0  
    ;
    ;
    banksel RB1PPS
    movlw 0
    movwf RB1PPS, BANKED  ; RB1   TX2  (  )
    bsf TRISB, 1          ;     
    ;
    banksel ANSELB
    bsf ANSELB, 2, BANKED ;      RB1  RB2   
    bsf ANSELB, 1, BANKED        
    ;
    ;
    banksel U2CON0    
    movlw b'10000000'; D7=BRGS=1  HiSpeed. D6=ABDEN (Auto-baud Detect), D5=TXEN=0, D4=RXEN, D3:D0 - MODE (0-Asynchronous 8-bit UART mode)
    movwf U2CON0, BANKED
    movlw b'10000000'; D7=ON
    movwf U2CON1, BANKED
    movlw b'10000000'; D7=RUNOVF, 1 -  .   
    movwf U2CON2, BANKED
    ;
    movlw KOO_BT
    movwf U2BRG, BANKED
    movlw KOO_BT>>8
    movwf U2BRGH, BANKED

    banksel U2FIFO
    bsf U2FIFO, TXBE, BANKED    ;    
    bsf U2FIFO, RXBE, BANKED    ;   
    ;
    ; TXEN  RXEN  
    return
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ;
    ;
    ;
Init_Datchiki:
    ; DS3231   -       +    
    ;
    clrf I2C_Error  
    movlw 0xd2; //  MCU6050  AD0=1
    movwf I2C_Adress    
    movlw 107;  // Reg 107 - Power Management 1
    movwf DS1621_Cmd
    movlw 32
    movwf DS1621_Byte0
    movlw 0xc7
    movwf DS1621_Byte1    
    rcall DS1621_Out3
    ;
    clrf I2C_Error  
    movlw 0xec; //  BMP280
    movwf I2C_Adress    
    movlw 0xF5;  // Reg F5 - config: D7-5  t_sb, D4-2 - filter, D0 - spi 3 wire. 
    movwf DS1621_Cmd
    clrf DS1621_Byte0
    rcall DS1621_Out2
    ;
    return
    ;
    ;
    ;
Read_Datchiki:
    rcall Read_Datchiki_DS3231
    rcall Read_Datchiki_BMP280
    bra Read_Datchiki_MCU6050
    ;
    ;
    ;
Read_Datchiki_DS3231:
    clrf I2C_Error  
    movlw 0xd0;  ds3231
    movwf I2C_Adress    
    clrf DS1621_Cmd   ;    Reg0 - [3],  , [3]
    ;
    lfsr FSR0, DS3231_Time
    movlw 7;     ([3], _, [3])
    rcall DS1621_InFSR0_W
    ;
    movlw 0xf         ;    Reg 0xf - Status, , [2]
    movwf DS1621_Cmd
    lfsr FSR0, DS3231_Status 
    movlw 4
    rcall DS1621_InFSR0_W
    ;
    banksel DS3231_Time
    movf I2C_Error, w
    bz LL_DS3231_NoErr
    movwf DS3231_TLo, BANKED    ;   I2C -  DS3231_TLo 
    clrf DS3231_Date, BANKED    ;        
    clrf DS3231_Date+1, BANKED
    clrf DS3231_Date+2, BANKED
LL_DS3231_NoErr:
    btfsc DS3231_Status, 7, BANKED ; Reg 0xF.D7 - Oscillator Stop Flag (OSF)
    bsf DS3231_TLo, 4, BANKED      ;   DS3231_TLo.4
    btfsc DS3231_Status, 2, BANKED ; Reg 0xF.D2 - Busy (BSY)
    bsf DS3231_TLo, 5, BANKED      ;   DS3231_TLo.5
    return
    ;
    ;
    ;
Read_Datchiki_BMP280:
    clrf I2C_Error  
    movlw 0xec;  bmp280
    movwf I2C_Adress    
    movlw 0xf7
    movwf DS1621_Cmd   ;    Reg [F7-FC] - 
    ;
    lfsr FSR0, BMP280_Izm_P_Hi ;   
    movlw 6
    rcall DS1621_InFSR0_W
    ;
    ;    
    movlw 0xF4;  // F4 - control: D7-5  osrs_t, D4-2 - osrs_p, D1,0 - mode. osrs_t=010  x2, osrs_p=101  x16, mode=01 - forced mode ( )
    movwf DS1621_Cmd
    movlw 0x75
    movwf DS1621_Byte0
    rcall DS1621_Out2
    ;
    banksel BMP280_CalibrIndex
    incf BMP280_CalibrIndex, w, BANKED
    andlw 31
    movwf BMP280_CalibrIndex, BANKED
    movlw 26
    cpfslt BMP280_CalibrIndex, BANKED
    clrf BMP280_CalibrIndex, BANKED
    ;
    movf BMP280_CalibrIndex, w, BANKED
    addlw 0x88;   [0x88-0xa1], 26 
    movwf DS1621_Cmd
    ;
    lfsr FSR0, BMP280_CalibrValue;   
    movlw 1
    rcall DS1621_InFSR0_W
    ;
    btfsc I2C_Error, 0
    bsf BMP280_CalibrIndex, 6, BANKED
    btfsc I2C_Error, 1
    bsf BMP280_CalibrIndex, 7, BANKED
    return
    ;
    ;
    ;
    ;
Read_Datchiki_MCU6050:
    clrf I2C_Error  
    movlw 0xd2        ; 0xd2 -  MCU6050  AD0=1
    movwf I2C_Adress    
    movlw 59          ; reg 59 -   
    movwf DS1621_Cmd   
    ;
    lfsr FSR0, MPU6050_Izms 
    movlw 2*4
    rcall DS1621_InFSR0_W
    ;
    return
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
DS1621_Out1:
    rcall I2C_Start
    movf I2C_Adress, w
    rcall I2C_Out
    movf DS1621_Cmd, w 
    rcall I2C_Out
    bra I2C_Stop
    ;
DS1621_Out2:
    rcall I2C_Start
    movf I2C_Adress, w    
    rcall I2C_Out
    movf DS1621_Cmd, w 
    rcall I2C_Out
    movf DS1621_Byte0, w 
    rcall I2C_Out
    bra I2C_Stop
    ;
    ;
DS1621_Out3:
    rcall I2C_Start
    movf I2C_Adress, w
    rcall I2C_Out
    movf DS1621_Cmd, w 
    rcall I2C_Out
    movf DS1621_Byte0, w 
    rcall I2C_Out
    movf DS1621_Byte1, w 
    rcall I2C_Out
    bra I2C_Stop
    ;
    ;
    ;
DS1621_In1:
    rcall I2C_Start
    movf I2C_Adress, w    
    rcall I2C_Out
    movf DS1621_Cmd, w 
    rcall I2C_Out
    ;
    rcall I2C_RepStart;   
    movf I2C_Adress, w
    rcall I2C_OutOr1;      
    ;
    rcall I2C_Input
    rcall I2C_Input_NAsk
    movf I2C_DataByte, w
    movwf DS1621_Byte0
    bra I2C_Stop
    ;
;DS1621_In2:
;    rcall I2C_Start
;    movf I2C_Adress, w    
;    rcall I2C_Out
;    movf DS1621_Cmd, w 
;    rcall I2C_Out
;    ;
;    rcall I2C_RepStart;   
;    movf I2C_Adress, w
;    rcall I2C_OutOr1;       
;    ;
;    rcall I2C_Input
;    rcall I2C_Input_Ask
;    movf I2C_DataByte, w
;    movwf DS1621_Byte0
;    ;
;    rcall I2C_Input
;    rcall I2C_Input_NAsk
;    movf I2C_DataByte, w
;    movwf DS1621_Byte1
;    bra I2C_Stop
;    ;
;DS1621_In3:
;    rcall I2C_Start
;    movf I2C_Adress, w    
;    rcall I2C_Out
;    movf DS1621_Cmd, w 
;    rcall I2C_Out
;    ;
;    rcall I2C_RepStart;   
;    movf I2C_Adress, w
;    rcall I2C_OutOr1;       
;    ;
;    rcall I2C_Input
;    rcall I2C_Input_Ask
;    movf I2C_DataByte, w
;    movwf DS1621_Byte0
;    ;
;    rcall I2C_Input
;    rcall I2C_Input_Ask
;    movf I2C_DataByte, w
;    movwf DS1621_Byte1
;    ;
;    rcall I2C_Input
;    rcall I2C_Input_NAsk
;    movf I2C_DataByte, w
;    movwf DS1621_Byte2
;    ;
;    bra I2C_Stop
    ;
    ;
    ;   I2C_Adress     DS1621_Cmd
    ;    FSR0   - W
DS1621_InFSR0_W:
    movwf WaitST
    rcall I2C_Start
    movf I2C_Adress, w    
    rcall I2C_Out
    movf DS1621_Cmd, w 
    rcall I2C_Out
    ;
    rcall I2C_RepStart;   
    movf I2C_Adress, w
    rcall I2C_OutOr1;       
    ;
DS1621_InFSR0_Lp:
    rcall I2C_Input
    movf I2C_DataByte, w
    movwf POSTINC0
    dcfsnz WaitST
    bra DS1621_InFSR0_End
    rcall I2C_Input_Ask
    bra DS1621_InFSR0_Lp
    ;    
DS1621_InFSR0_End:
    rcall I2C_Input_NAsk
    bra I2C_Stop    
    ;
    ;   
    ;
I2C_Start:
    rcall I2C_SCL_Hi
    rcall I2C_SDA_Hi
    rcall I2C_Wait
    rcall I2C_SDA_Lo
    bra I2C_Wait
    ;
I2C_Stop:
    rcall I2C_SCL_Lo
    rcall I2C_Wait
    rcall I2C_SDA_Lo
    rcall I2C_Wait
    rcall I2C_SCL_Hi
    rcall I2C_Wait
    rcall I2C_SDA_Hi
    bra I2C_Wait
    ;
I2C_RepStart:
    rcall I2C_SCL_Lo
    rcall I2C_Wait
    rcall I2C_SDA_Hi
    rcall I2C_Wait
    rcall I2C_SCL_Hi
    rcall I2C_Wait
    rcall I2C_SDA_Lo
    bra I2C_Wait
    ;
    ;
    ;
    ;
    ;
    ;           w     1    I2C  (  I2C-)
I2C_OutOr1:  
    iorlw 1
    ;
    ;           w -   I2C 
I2C_Out:  
    movwf I2C_DataByte
    movlw 9
    movwf I2C_OutBitST
    ;
I2C_Out_OutBit:
    rcall I2C_SCL_Lo
    rcall I2C_Wait
    ;
    bcf I2CLAT, IC2DataBit
	rlcf I2C_DataByte, w;         SDA    
    btfsc STATUS, C
    bsf I2CTRIS, IC2DataBit
	btfss STATUS, C
    bcf I2CTRIS, IC2DataBit
    rcall I2C_Wait
    ;
    rcall I2C_SCL_Hi;            SCL  	
    rcall I2C_Wait
    ;
    ;   ,      
    bcf STATUS, C
    btfsc I2CPORT, IC2DataBit
    bsf STATUS, C
    rrcf I2C_DataByte, w
    xorwf I2C_DataByte, w
    andlw 0x80
    bnz I2C_Out_NoData
    ;
    ;    
    bsf STATUS, C
    rlcf I2C_DataByte
    decfsz I2C_OutBitST
    bra I2C_Out_OutBit
    ; 
    ; ,  9-    , .. ACK 
    bsf I2C_Error, 0
    return;
    ;
    ;
I2C_Out_NoData:
    decfsz I2C_OutBitST
    bra I2C_Out_Error
    ; ,   
    return
    ;
I2C_Out_Error:
    ;  ,      
    bsf I2C_Error, 1
    return;
    ;
    ;
I2C_Input:
    movlw 8
    movwf I2C_OutBitST
    ;
I2C_Input_InBit:
    rcall I2C_SCL_Lo;         
    rcall I2C_Wait
    rcall I2C_SDA_Hi;         
    rcall I2C_Wait
    rcall I2C_SCL_Hi;         
    rcall I2C_Wait
    ;
    bcf STATUS, C;             
    btfsc I2CPORT, IC2DataBit
    bsf STATUS, C
    rlcf I2C_DataByte
    ;
    decfsz I2C_OutBitST
    bra I2C_Input_InBit
    ;
    movf I2C_DataByte, w
    return
    ;
    ;    
I2C_Input_Ask:
    rcall I2C_SCL_Lo
    rcall I2C_Wait
    rcall I2C_SDA_Lo
    rcall I2C_Wait
    rcall I2C_SCL_Hi
    bra I2C_Wait
    ;
I2C_Input_NAsk:
    rcall I2C_SCL_Lo
    rcall I2C_Wait
    rcall I2C_SDA_Hi
    rcall I2C_Wait
    rcall I2C_SCL_Hi
    bra I2C_Wait
    ;
    ;
I2C_SCL_Lo:
    bcf I2CLAT, IC2SyncBit
	bcf I2CTRIS, IC2SyncBit;            SCL
    return
I2C_SCL_Hi:
    bcf I2CLAT, IC2SyncBit
	bsf I2CTRIS, IC2SyncBit;            SCL
    return
I2C_SDA_Lo:
    bcf I2CLAT, IC2DataBit
	bcf I2CTRIS, IC2DataBit
	return	
I2C_SDA_Hi:
    bcf I2CLAT, IC2DataBit
	bsf I2CTRIS, IC2DataBit
	return	
    ;
    ;
I2C_Wait:
    movlw 4
I2C_Wait_L1: 
    addlw -1
    bnz I2C_Wait_L1
    return
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ; ************************************************************************** 
    ;
    ;    
EKG_Process:
    banksel Acp_Diff
    btfss Acp_Diff+2, 7, BANKED
    bra EKG_Pr_DPoloj
    bsf STATUS, C
    movlw 0
    SUBFWB Acp_Diff, f, BANKED    ;     Acp_Diff
    SUBFWB Acp_Diff+1, f, BANKED
    SUBFWB Acp_Diff+2, f, BANKED
EKG_Pr_DPoloj:
    movf Acp_Diff+2, w, BANKED
    bz EKG_Pr_NoPere
    setf Acp_Diff, BANKED; :    16  
    setf Acp_Diff+1, BANKED
EKG_Pr_NoPere:
    ;
    ;
    ;    -      
    ;MWriteAcpBufNCH Acp_Diff
    ;
    ;   : Acp_Sqr := Acp_Diff ^ 2
    ;
    movf Acp_Diff, w, BANKED
    mulwf Acp_Diff, BANKED
    movf PRODL, w
    movwf Acp_Sqr
    movf PRODH, w
    movwf Acp_Sqr+1
    ;
    movf Acp_Diff+1, w, BANKED
    mulwf Acp_Diff+1, BANKED
    movf PRODL, w
    movwf Acp_Sqr+2
    movf PRODH, w
    movwf Acp_Sqr+3
    ;
    movf Acp_Diff, w, BANKED
    mulwf Acp_Diff+1, BANKED
    movf PRODL, w
    addwf Acp_Sqr+1
    movf PRODH, w
    addwfc Acp_Sqr+2
    movlw 0
    addwfc Acp_Sqr+3
    movf PRODL, w
    addwf Acp_Sqr+1
    movf PRODH, w
    addwfc Acp_Sqr+2
    movlw 0
    addwfc Acp_Sqr+3
    ;  Acp_Sqr !
    ;
    ;  1  EkgS2 -      
    ; : EkgS2 -= EkgS1
    movf EkgS1, w, BANKED
    subwf EkgS2, f, BANKED
    movf EkgS1+1, w, BANKED
    subwfb EkgS2+1, f, BANKED
    movf EkgS1+2, w, BANKED
    subwfb EkgS2+2, f, BANKED
    movf EkgS1+3, w, BANKED
    subwfb EkgS2+3, f, BANKED
    movf EkgS1+4, w, BANKED
    subwfb EkgS2+4, f, BANKED
    ;
    ;  EkgS1,  Acp_Sqr  EkgBuf1  EkgNak1Pos
    movlw 4
    addwf EkgNak1Pos, w, BANKED ;   EkgNak1Pos    EkgBuf1
    andlw 7*4
    movwf EkgNak1Pos, BANKED    
    lfsr FSR2, EkgBuf1       ;   FSR2   
    addwf FSR2L
    ;
    movf POSTINC2, w            ;  EkgS1 -= [FSR2]
    subwf EkgS1+0, f, BANKED
    movf POSTINC2, w
    subwfb EkgS1+1, f, BANKED
    movf POSTINC2, w
    subwfb EkgS1+2, f, BANKED
    movf POSTINC2, w
    subwfb EkgS1+3, f, BANKED
    movlw 0
    subwfb EkgS1+4, f, BANKED
    ;
    movlw -4
    addwf FSR2L
    ;
    movf Acp_Sqr+0, w, BANKED    ;  [FSR2] := Acp_Sqr  EkgS1 += Acp_Sqr
    movwf POSTINC2
    addwf EkgS1+0, f, BANKED
    movf Acp_Sqr+1, w, BANKED
    movwf POSTINC2
    addwfc EkgS1+1, f, BANKED
    movf Acp_Sqr+2, w, BANKED
    movwf POSTINC2
    addwfc EkgS1+2, f, BANKED
    movf Acp_Sqr+3, w, BANKED
    movwf POSTINC2
    addwfc EkgS1+3, f, BANKED
    movlw 0
    addwfc EkgS1+4, f, BANKED
    ;
    ;
    ;  2  EkgS2 -      
    ;  EkgS2 += Acp_Sqr * AperN
    ;
    movf Acp_Sqr, w, BANKED
    mullw AperN
    movf PRODL, w
    addwf EkgS2, f, BANKED
    movf PRODH, w
    addwfc EkgS2+1, f, BANKED
    movlw 0
    addwfc EkgS2+2, f, BANKED
    addwfc EkgS2+3, f, BANKED
    addwfc EkgS2+4, f, BANKED
    ;
    movf Acp_Sqr+1, w, BANKED
    mullw AperN
    movf PRODL, w
    addwf EkgS2+1, f, BANKED
    movf PRODH, w
    addwfc EkgS2+2, f, BANKED
    movlw 0
    addwfc EkgS2+3, f, BANKED
    addwfc EkgS2+4, f, BANKED
    ;
    movf Acp_Sqr+2, w, BANKED
    mullw AperN
    movf PRODL, w
    addwf EkgS2+2, f, BANKED
    movf PRODH, w
    addwfc EkgS2+3, f, BANKED
    movlw 0
    addwfc EkgS2+4, f, BANKED
    ;
    movf Acp_Sqr+3, w, BANKED
    mullw AperN
    movf PRODL, w
    addwf EkgS2+3, f, BANKED
    movf PRODH, w
    addwfc EkgS2+4, f, BANKED
    ;
    ;   EkgS2     
    ;
    ;
    lfsr FSR2, EkgBuf3
    movf EkgNak1Pos, w, BANKED;      EkgNak1Pos
    addwf FSR2L
    ;
    movf POSTINC2, w            ;  EkgS3 -= [FSR2]
    subwf EkgS3+0, f, BANKED
    movf POSTINC2, w
    subwfb EkgS3+1, f, BANKED
    movf POSTINC2, w
    subwfb EkgS3+2, f, BANKED
    movf POSTINC2, w
    subwfb EkgS3+3, f, BANKED
    movlw 0
    subwfb EkgS3+4, f, BANKED
    ;
    movlw -4
    addwf FSR2L
    ;
    movf EkgS2+1, w, BANKED    ;  [FSR2] := (EkgS2>>8)  EkgS3 += (EkgS2>>8)
    movwf POSTINC2
    addwf EkgS3+0, f, BANKED    
    movf EkgS2+2, w, BANKED
    movwf POSTINC2
    addwfc EkgS3+1, f, BANKED    
    movf EkgS2+3, w, BANKED
    movwf POSTINC2
    addwfc EkgS3+2, f, BANKED    
    movf EkgS2+4, w, BANKED
    movwf POSTINC2
    addwfc EkgS3+3, f, BANKED    
    movlw 0
    addwfc EkgS3+4, f, BANKED
    ;
    ;
    ;
    ;  
    ; 
    movf EkgS3+1, w, BANKED;         EkgPorog  (EkgS3>>8), xxx = EkgPorog-(EkgS3>>8)
    subwf EkgPorog+0, w, BANKED
    movf EkgS3+2, w, BANKED
    subwfb EkgPorog+1, w, BANKED
    movf EkgS3+3, w, BANKED
    subwfb EkgPorog+2, w, BANKED
    movf EkgS3+4, w, BANKED
    subwfb EkgPorog+3, w, BANKED
    bnc EKG_Pr_CmpResMenshe
    ;
    ;    ->  
    ;
    movf EkgPorog+3, w, BANKED
    mullw EkgPorogTauMul
    movf PRODL, w
    movwf EkgDPorog+2, BANKED
    movf PRODH, w
    movwf EkgDPorog+3, BANKED
    ;
    movf EkgPorog+2, w, BANKED
    mullw EkgPorogTauMul
    movf PRODL, w
    movwf EkgDPorog+1, BANKED
    movf PRODH, w
    addwf EkgDPorog+2, f, BANKED
    movlw 0
    addwfc EkgDPorog+3, f, BANKED
    ;
    movf EkgPorog+1, w, BANKED
    mullw EkgPorogTauMul
    movf PRODL, w
    movwf EkgDPorog+0, BANKED
    movf PRODH, w
    addwf EkgDPorog+1, f, BANKED
    movlw 0
    addwfc EkgDPorog+2, f, BANKED
    addwfc EkgDPorog+3, f, BANKED
    ;
    movf EkgPorog+0, w, BANKED
    mullw EkgPorogTauMul
    movf PRODH, w
    addwf EkgDPorog+0, f, BANKED
    movlw 0
    addwfc EkgDPorog+1, f, BANKED
    addwfc EkgDPorog+2, f, BANKED
    addwfc EkgDPorog+3, f, BANKED
    ;
    ;
    movf EkgDPorog+1, w, BANKED
    subwf EkgPorog, f, BANKED
    movf EkgDPorog+2, w, BANKED
    subwfb EkgPorog+1, f, BANKED
    movf EkgDPorog+3, w, BANKED
    subwfb EkgPorog+2, f, BANKED
    movlw 0
    subwfb EkgPorog+3, f, BANKED
    ;
    bra EKG_Pr_PorOK
    ; 
EKG_Pr_CmpResMenshe: ;  EkgPorog < (EkgS3>>8) ->  
    movf EkgS3+1, w, BANKED
    movwf EkgPorog+0, BANKED
    movf EkgS3+2, w, BANKED
    movwf EkgPorog+1, BANKED
    movf EkgS3+3, w, BANKED
    movwf EkgPorog+2, BANKED
    movf EkgS3+4, w, BANKED
    movwf EkgPorog+3, BANKED
    ;
EKG_Pr_PorOK:    
    ;
    bcf STATUS, C
    rrcf EkgPorog+3, w, BANKED  ;   EkgDPorog := EkgPorog/2
    movwf EkgDPorog+3, BANKED
    rrcf EkgPorog+2, w, BANKED
    movwf EkgDPorog+2, BANKED
    rrcf EkgPorog+1, w, BANKED
    movwf EkgDPorog+1, BANKED
    rrcf EkgPorog+0, w, BANKED
    movwf EkgDPorog+0, BANKED
    ;
    movf EkgS3+1, w, BANKED;         EkgDPorog  (EkgS3>>8), xxx = EkgDPorog - (EkgS3>>8)
    subwf EkgDPorog+0, w, BANKED
    movf EkgS3+2, w, BANKED
    subwfb EkgDPorog+1, w, BANKED
    movf EkgS3+3, w, BANKED
    subwfb EkgDPorog+2, w, BANKED
    movf EkgS3+4, w, BANKED
    subwfb EkgDPorog+3, w, BANKED
    bc LL_NoPulse; bnc,  EkgDPorog < (EkgS3>>8), ..  
    ;
    ;  R - 
    btfsc EkgLedStat, 0, BANKED
    bra LL_EkgLedAnime;       
    ;
    infsnz CH2_Lo;    
    incf CH2_Hi
    ;
    bsf EkgLedStat, 0, BANKED
    movlw 1
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    movlw 30
    movwf EkgLedN, BANKED; .  
    bra LL_EkgLedAnime
    ;
LL_NoPulse:
    bcf EkgLedStat, 0, BANKED
LL_EkgLedAnime: 
    ;  ,    D0  EkgLedN,  ,    
    btfss EkgLedN, 0, BANKED
    bsf Led_Lat, Led_Bit;   
    btfsc EkgLedN, 0, BANKED
    bcf Led_Lat, Led_Bit;    
    ;
    decf EkgLedN, f, BANKED    
    infsnz EkgLedN, w, BANKED
    clrf EkgLedN, BANKED
    return
    ;
    ;
    ;
    END 

